﻿var Player =
{             
           
                buffering_timer : null,
                plugin : null,
                mwPlugin: null,
                state : -1,
                skipState : -1,
                stopCallback : null,
                originalSource : null,
                size : 0,
                w: 0,
                h: 0,
                STOPPED : 0,
                LOADING : 1,
                PLAYING_LIVE : 2,
                PLAYING_VOD : 3,
                PAUSA_VOD : 4,
                statusmessage : "",
                vod_duration : 0,
                vod_current_time : 0,
                delta_time : 0,
                next : false,
                repeat : false,
                get : 1,
                re : 1,
                s2_time: 0,
                s5_time: 0,
                s: 0,
                sp: 0,
                jump : 0,
}

Player.init = function()
{
                var success = true;
                this.state = this.STOPPED;
                this.plugin = document.getElementById("pluginPlayer");
                this.mwPlugin = document.getElementById("pluginObjectTVMW");

                if (!this.plugin )
                {
                    success = false;
                }

                
                if (!this.mwPlugin || !this.mwPlugin.GetSource) 
                {
                    success = false;
                } 
                else 
                {
                    this.originalSource = this.mwPlugin.GetSource();
                    this.mwPlugin.SetMediaSource();
                }
                if (this.plugin["SetTotalBufferSize"] != undefined)
                    this.plugin.SetTotalBufferSize(20 * 1024 * 1024);
                    this.plugin.SetInitialBuffer(20);
                if (this.plugin["SetPendingBuffer"] != undefined)
                    this.plugin.SetPendingBuffer(40);

                this.plugin.OnBufferingStart = 'Player.onBufferingStart';
                this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
                this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
                this.plugin.OnCurrentPlayTime = 'Player.CurrentTime';
                this.plugin.OnStreamInfoReady = 'Player.OnStreamInfoReady';	
                this.plugin.OnConnectionFailed = 'Player.OnConnectionFailed';
                this.plugin.OnNetworkDisconnected = 'Player.OnNetworkDisconnected';
                this.plugin.OnStreamNotFound = 'Player.OnStreamNotFound';
                this.plugin.OnRenderError = 'Player.OnRenderError';
                this.plugin.onServerError = 'Player.onServerError';
                this.size = parseInt(API.Size);

    return success;

}


Player.OnConnectionFailed = function()
{
                Display.status("Connection Failed !");
                ConsoleLog('OnConnectionFailed');
                setTimeout("Player.ReturnMenu()", 2000);    
}

Player.OnNetworkDisconnected = function()
{
                Display.status("Network Disconnected !");
                ConsoleLog('Network Disconnected');
                setTimeout("Player.ReturnMenu()", 2000);    
}

Player.OnStreamNotFound = function()
{
                Display.status("Stream Not Found!");
                ConsoleLog('Stream NotFound!');
                setTimeout("Player.ReturnMenu()", 2000);    
}

Player.OnStreamInfoReady = function()
{      
                if(this.state!= this.STOPPED)  
                { 
                    Display.setTotalTime(Player.plugin.GetDuration());               
                    setTimeout("Player.GetVideoSize()", 200);         
                }
                Display.loadinghide();
}

Player.OnRenderError = function()
{
                
                if ( this.re<5)
                {
                    this.plugin.Play( this.url );
                    this.re++;
                }
                else 
                { 
                    Display.status("Render Error!");
                    setTimeout("Player.ReturnMenu()", 2000);
                    Display.loadinghide();
                }    
}

Player.onServerError = function()
{
                Display.status("Server Error!");
                ConsoleLog('Server Error!');  
                setTimeout("Player.ReturnMenu();", 2000);
}

getBandwidth = function(bandwidth){ }

onDecoderReady = function(){ }

onRenderError = function() { }

Player.onBufferingStart = function()
{
                Display.status("Buffering...");
                Player.bufferingTimer();
                ConsoleLog("Buffering...");
}

Player.onBufferingProgress = function(percent)
{
                Display.status("Buffering:" + percent + "%");
                ConsoleLog("Buffering:" + percent + "%");
}

Player.onBufferingComplete = function()
{
                Display.status("Buffering Complete");
                ConsoleLog("Buffering Complete");
                clearTimeout(this.buffering_timer);
                ConsoleLog("clearTimeout");        	   
                if(this.state!= this.STOPPED )
                {
                               if(Player.plugin.GetDuration()>0 && Main.StreamMode != "mms" && Main.StreamMode != "hls" || Main.StreamMode == "http.mp3")
                                {
                                    this.jump=0;
                                    KeyHandler.setFocus(Main.VODPlayer_ID);
                                    this.state = this.PLAYING_VOD;
                                    setTimeout ("Player.saveTime()", 3000 );
                                    this.s=0;
                                }
                                else
                                {
                                    KeyHandler.setFocus(Main.LivePlayer_ID);
                                    this.state = this.PLAYING_LIVE; 
                                }
                    Display.loadinghide();
                     
                    if (this.sp==0)
                    { 
                        this.sp=1;
                        Display.showplayer(); 
                        Main.unregistTVKey();
                    }
                    else
                        Display.hideplayer();
                }
}

Player.ReturnMenu = function()
{
                Player.stopVideo();
                Main.Menu();
                this.repeat=false;
                this.next=false;
}             

Player.bufferingTimer = function()
{   
                if (this.state == this.PLAYING_LIVE )
                {
                                if(Main.StreamMode == "udp" && Main.serieC)
                                    this.buffering_timer=setTimeout("Player.playVideo();",30000);
                                else if(Main.serieC)
                                    this.buffering_timer=setTimeout("Player.playVideo();",6000);
                                else if(Main.StreamMode == "udp")
                                    this.buffering_timer=setTimeout("Player.playVideo();",9000);
                                else
                                    this.buffering_timer=setTimeout("Player.playVideo();",5000);
                }
                else if (this.state == this.PLAYING_VOD)
                    this.state = this.LOADING;

}
 

Player.deinit = function()
{
                if (this.plugin)
                this.plugin.Stop();
                ConsoleLog("Player deinit !!! " ); 
                if(this.mwPlugin != null)
               this.mwPlugin.SetMediaSource(this.originalSource);
}

Player.setVideoURL = function(url)
{
                this.url = url;
                ConsoleLog("URL = " + this.url);
}

Player.playVideo = function()
{
                if (this.url != null)
                {
                                if ( this.state!= this.STOPPED) 
                                    this.plugin.Stop();
                                    this.state = this.LOADING;
                                    Display.loadingshow();
                                    var d2mode = Screen.getModeD2();
                                if(d2mode!=0)
                                {            
                                    this.plugin.InitPlayer(this.url);
                                    this.plugin.SetPlayerProperty(2, "3", d2mode);
                                    this.plugin.StartPlayback();
                                    this.size=0;
                                }
                                else if(Main.StreamMode == "http.mp3" && Main.serieC==false)
                                {            
                                    this.plugin.InitPlayer(this.url);
                                    this.plugin.SetPlayerProperty(5, "MP3", 0);
                                    this.plugin.StartPlayback();
                                    this.size=0;
                                }
                                else this.plugin.Play( this.url );
                                
                    pluginAPI.setOffScreenSaver();
                    Audio.plugin.SetSystemMute(false);
                    ConsoleLog("Play");
                }
                else ConsoleLog(" url= null Not Play");
}



Player.getState = function()
{
                return this.state;
}

stopPlayer = function()
{
                Player.stopVideo();
}

Player.stopVideo = function()
{
                if(this.state!= this.STOPPED )
                {
                this.plugin.Stop();
                this.state = this.STOPPED;
                Display.hideplayer();
                Display.loadinghide();
                clearTimeout(this.buffering_timer);
                this.jump=0;
                this.re=1;
                this.sp=0;
                Main.registTVKey(); 
                document.getElementById("statusbar").style.display="none";
                }
}


Player.ShowResolution = function()
{
                var w1=this.w;
                var h1=this.h;
                var res = "<center>" + w1 + "X" + h1 + "</center>";
                widgetAPI.putInnerHTML(document.getElementById("resolution"), res);
}

Player.setBuffer = function(buffer) 
{ 
                this.plugin.SetTotalBufferSize(buffer);
                ConsoleLog("setTottalBuffer " + buffer);
}




Player.GetVideoSize = function()
{  
                if(this.state!= this.STOPPED)
                {
                    this.get++;   
                    this.h= this.plugin.GetVideoHeight();
                    this.w= this.plugin.GetVideoWidth();
                                if(this.w==0 && this.get<5)
                                    setTimeout("Player.GetVideoSize()", 50)
                                else
                                {
                                    this.get=1;
                                                if(this.w==5)
                                                {
                                                    this.h=432;
                                                    this.w=540;
                                                }
                                                else if(this.w==4)
                                                {
                                                    this.h=270;
                                                    this.w=480;
                                                }
                                                else if(this.w==3)
                                                {
                                                    this.h=288;
                                                    this.w=384;
                                                }
                                                else if( this.w<128 )
                                                {
                                                    this.h=0;
                                                    this.w=0;
                                                }
                                                Player.ShowResolution(); 
                                                if(this.size ==4)
                                                    setTimeout("Player.setSize(Player.size,0)", 700);
                                                else
                                                    setTimeout("Player.setSize(Player.size,0)", 500);
                                }
                }
}


Player.setSize=function(mode, show)
 {
                if(this.state!= this.STOPPED) 
                {                         
                this.size=mode;
                var w = this.w;
                var h = this.h;
                var l ,t ,m ,y ; 
                if( this.w>0 )
                this.plugin.SetDisplayArea(0, 0, 960, 540);
                if (this.w==0 || this.size==4)
                this.plugin.SetCropArea(0, 0, 0, 0);
               
                switch(mode)
                                {
                                                case 0 :
                                                if(w==0 )
                                                { 
                                                    if(show>0)
                                                    Display.status('w/h=2');
                                                    this.plugin.SetDisplayArea(0,30,960,480); 
                                                }
                                                else
                                                { 
                                                    if(show>0)
                                                    Display.status('16x9 FULL');
                                                    this.plugin.SetCropArea(0, 0, w, h);
                                                }
                                                break;

                                                case 1 :
                                                if(w==0)
                                                { 
                                                    if(show>0)
                                                    Display.status('w/h=1.78');
                                                    this.plugin.SetDisplayArea(0,0,960,540); 
                                                }
                                                else
                                                {
                                                    t = (Math.round(0.0625*h/2))*2;
                                                    h = (Math.round(0.875*h/2))*2;
                                                    if(show>0)
                                                    Display.status('14x9 ZOOM');
                                                    this.plugin.SetCropArea(0, t, w, h);
                                                }
                                                break;

                                                case 2 :
                                                if(w==0)
                                                { 
                                                    if(show>0)
                                                    Display.status('w/h=1.67');
                                                    this.plugin.SetDisplayArea(30,0,900,540); 
                                                }
                                                else
                                                {
                                                                if(w/h>1.76)
                                                                {
                                                                    m = (Math.round((960*h/w)/2))*2;
                                                                    y = (Math.round((540-m)/4))*2;
                                                                    if(show>0)
                                                                    Display.status('ORIGINAL');
                                                                    this.plugin.SetCropArea(0, 0, w, h);
                                                                    this.plugin.SetDisplayArea(0, y, 960, m);
                                                                }
                                                                else
                                                                {
                                                                    t = (Math.round(0.115*h/2))*2;
                                                                    h = (Math.round(0.77*h/2))*2;
                                                                    if(show>0)
                                                                    Display.status('4x3 KINOZOOM');
                                                                    this.plugin.SetCropArea(0, t, w, h);
                                                                }
                                                }
                                                break;

                                                case 3 :
                                                if(w==0)
                                                { 
                                                    if(show>0)
                                                    Display.status('w/h=1.56');
                                                    this.plugin.SetDisplayArea(60,0,840,540);  
                                                }
                                                else
                                                {
                                                    l = (Math.round(0.0625*w/2))*2;
                                                    t = (Math.round(0.0625*h/2))*2;
                                                    w =(Math.round(0.875*w/2))*2;
                                                    h =(Math.round(0.875*h/2))*2;
                                                    if(show>0)
                                                    Display.status('16x9 ZOOM');
                                                    this.plugin.SetCropArea(l, t, w,h);
                                                }
                                                break;

                                                case 4 :
                                                if(w<=732 && w/h<1.35 || this.w==0)
                                                {
                                                    if(show)
                                                    Display.status('4x3');
                                                    this.plugin.SetDisplayArea(120,0,720,540);
                                                }
                                                break;
                                }
                }
}

Player.getSize=function() {return this.size;}


Player.MinutesJump = function(minutes) 
{
              if(this.jump==0)
               {
                    var current_min = this.vod_current_time/60000*-1;
                    var end_min = this.delta_time/60000;              
                    var sign = "";
                                if(minutes>0)
                                {
                                    sign = "+";

                                                if(minutes < end_min )
                                                {
                                                    this.plugin.JumpForward(minutes*60); 
                                                    this.jump=1;
                                                }
                                                else 
                                                {
                                                    this.s=1;this.delta_time =0;
                                                    Player.CurrentTime();
                                                }
                                }  
                                else if (minutes< 0 )
                                {
                                                if(minutes > current_min )
                                               {
                                                    this.plugin.JumpBackward(minutes*60*-1);
                                                    this.jump=1;}
                                                else 
                                                {
                                                    this.s=1;this.delta_time =0;
                                                    Player.CurrentTime();
                                                }
                                }
                                this.statusmessage =sign + minutes + " мин.";
                                Display.status(this.statusmessage); 

                                if(this.jump==1)
                                {
                                this.state = this.PAUSA_VOD;
                                Display.showplayer();
                                Display.loadingshow();
                                }
                }
}

Player.PercentJump = function(percent) 
{
                if(this.jump==0)
                {
                    this.statusmessage = percent*10 + "%";
                    var jump_to_minutes = (this.vod_duration*percent/10 - this.vod_current_time)/1000;
                                if (jump_to_minutes > 0)
                                {
                                    this.plugin.JumpForward(jump_to_minutes); 
                                    this.jump=1;
                                }
                                else if (jump_to_minutes < 0)
                                {
                                    this.plugin.JumpBackward(jump_to_minutes*-1);
                                    this.jump=1;

                                }
                                widgetAPI.putInnerHTML(Display.statusDiv,(this.statusmessage));
                                if(this.jump==1)
                                {
                                    this.state = this.PAUSA_VOD;
                                    Display.showplayer();
                                    Display.loadingshow();
                                    clearTimeout(Display.loadingshow_timer);
                                }
                }
}

Player.resumeVideo = function()
{
                if (this.state != this.STOPPED)
                {
                    this.state = this.PLAYING_VOD;
                    this.plugin.Resume();
                    Display.status(' > > >  ');
                    if (Main.StreamMode != "http.mp3")
                    Display.hideplayer(); 
                    Display.loadinghide();   
                }
}

Player.pauseVideo = function()
{
                if (this.state != this.STOPPED)
                {
                    this.state = this.PAUSA_VOD;
                    this.plugin.Pause();
                    Display.showplayer();
                    widgetAPI.putInnerHTML(Display.statusDiv, "Пауза");
                }
}

Player.CurrentTime = function(time)
{
                        
                if(this.state == this.PLAYING_VOD)
                {              
                    Display.setTime(time);
                    this.vod_current_time = time;
                    this.vod_duration = Player.plugin.GetDuration();
                    if(this.s==0)
                    this.delta_time =this.vod_duration - this.vod_current_time;
                    this.s=0;
                                if(this.delta_time==0 && this.vod_duration!=0 && this.vod_current_time!=0)
                                {
                                                if(this.repeat==true && this.next==true)
                                                {
                                                    this.state = this.LOADING;
                                                    Display.hideplayer();
                                                    Display.loadingshow();
                                                    Player.playVideo();
                                                }
                                                else if(this.next==true)
                                                {
                                                    Player.stopVideo();
                                                    Main.selectNextChannel();
                                                    Main.PlayChannel();
                                                }
                                                else 
                                                    Player.ReturnMenu();
                                }
                                else if(this.delta_time==0)
                                {
                                Player.ReturnMenu();
                                Display.status('Сбой в сети!');
                                } 
                }
}

Player.saveTime = function()
{
this.s2_time = this.vod_current_time;alert("save");
setTimeout ("Player.resumeTime2sec()", 2000 );  
}

Player.resumeTime2sec = function()
{
                if(this.state == this.PLAYING_VOD)
                {
                                if(this.s2_time == this.vod_current_time )
                                {
                                    this.plugin.Resume();
                                    setTimeout ("Player.saveTime()", 1000 );  
                                    this.s5_time == this.s2_time;
                                    setTimeout ("Player.resumeTime5sec()", 3000 );
                                    alert("resume2sec");
                                }
                                else Player.saveTime();
                }
}

Player.resumeTime5sec = function()
{ 
                if(this.state == this.PLAYING_VOD &&this.s5_time == this.vod_current_time)
                {
                    this.plugin.JumpForward(this.s5_time/1000);
                    Display.status('! > > > !');
                    alert("resume5sec");
                }

}