/**
* @file      Youtube.js
* @brief     설정의 서비스 사이트 추가시 ID, PW 유효 확인.
* @author    Hyun Park
* @date      30 JAN 2009 
*/

var Youtube = {
	/* for XHR Connection */
	bMaple : true,
	tokenXHR : null,
	infoXHR : null,
	
	/* SP Define require */
	vDictTokenKey : "Youtubetoken",	
	vDictYoutubeID : "Youtubeid",
	vDictYoutubePW : "Youtubepw",
	
	uccNNaviToken : "",
	uccYouTubeID : "",
	uccYouTubePW : "",
	uccYouTubeToken : "",
	
	 loginFile : "loginInfo.txt",
	 bLogin : false,
	 
	 loginID : "",
	 loginPW : "",
	 
	 callbackFunc : null,	 
 	
	/*test */
	favoriteDir : "",
	loginFile : "loginInfo.txt"	
}

/**
 * @brief		계정확인 
 * @remarks		설정에서 유튜브 서비스사이트 ID, PW 등록시 유효성 확인.
* @param		id : ID , pw : password , callbackFunc : 유효한 ID인지 아닌지를 담아갈 callback
* @return		void
*/
Youtube.checkAccount = function(id, pw, callbackFunc) {
	TRACE ("Start getYouTubeToken()");
	this.callbackFunc = callbackFunc;

    var url = "https://www.google.com/youtube/accounts/ClientLogin";
    var Youtubedata = "Email="+id+"&Passwd="+pw+"&service=youtube&source=sample";
	TRACE("Youtubedate :" + Youtubedata);
    if (window.XMLHttpRequest) 	{
        // code for Mozilla, etc.
        if(this.tokenXHR==null) {
            this.tokenXHR=new XMLHttpRequest();
             if (this.tokenXHR.overrideMimeType) {
                this.tokenXHR.overrideMimeType('text/xml');
            }
        } else {
			this.tokenXHR.destroy();
			this.tokenXHR = new XMLHttpRequest();
			if (this.tokenXHR.overrideMimeType) {
				this.tokenXHR.overrideMimeType('text/xml');
			}
		}
    } else if (window.ActiveXObject) {
        // code for IE
        this.tokenXHR = new ActiveXObject("Microsoft.XMLHTTP")
    }
    if (this.tokenXHR!=null) {
        this.tokenXHR.onreadystatechange=Youtube.onLoadYouTubeToken;
		this.tokenXHR.open("POST",url,true);

        this.tokenXHR.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
//        this.tokenXHR.setRequestHeader("Content-length", Youtubedata.length);
//        this.tokenXHR.setRequestHeader("Connection", "close");
        this.tokenXHR.send(Youtubedata);
    } else 	{
        TRACE("Your browser does not support XMLHTTP.");
    }
	TRACE ("End getYouTubeToken()");	
}

/**
 * @brief		로그인 시도후 token 값을 확인
 * @remarks		
* @param		void
* @return		void
*/
Youtube.onLoadYouTubeToken = function() {
	TRACE("onLoadYouTubeToken :: "+ Youtube.tokenXHR)
	try{
	if(Youtube.checkReadyStateLogin(Youtube.tokenXHR, "tokenXHR")) {
		// code for IE
		//response = infoXHR.responseXML.documentElement;

    	var auth = Youtube.tokenXHR.responseText;
    	var authindex = "";
    	var tmp = "";
    	var token = "";
    
    	authindex = auth.indexOf("Auth=");
    	tmp = auth.substr(authindex + 5, auth.length - authindex);
    
    	authindex = tmp.indexOf("YouTubeUser=");
    	token = tmp.substr(0, authindex - 1);

		alert(token);
		
    	this.uccYouTubeToken = token;
		
		TRACE("uccYouTubeToken = " + this.uccYouTubeToken);
		if ( this.uccYouTubeToken != "")	 {
			this.bLogin = true;
			Youtube.callbackFunc("TRUE");
		} else {
			this.bLogin = false;
			Youtube.callbackFunc("FALSE");
		}				
	} 
	}catch(e){
		alert("onLoadYouTubeToken :error : "+e)
	}
}

/**
 * @brief		XML http request ready state 값 검사
 * @remarks		XHR에서 status가 바뀔때 마다 호출이 되며, state가 done(4)이 되면 true를 리턴한다.
* @param		obj			XHR Object
* @return       void
*/
Youtube.checkReadyStateLogin = function(obj, type) {
	TRACE("checkReadyStateLogin :: "+obj.readyState)
	try{
	if(obj.readyState == 4) {        
        TRACE(type + ", status = " + obj.status);
        if(obj.status == 200 || obj.status == 201) { 
        	TRACE("login success");
			return true;
        } else {		
			TRACE( " obj.status = " + obj.status);
            TRACE("XHR Network ERROR!!!! " + type);
			Youtube.callbackFunc("ERROR");
			TRACE("login Fail!!!");
			this.bLogin = false;						
        }		
    }
    return false;
	}catch(e){
		alert("checkReadyStateLogin error :: "+e)
	}
}
