/**
* @file         googleSuggest.js
* @brief        AutoComplete (Google Suggest) Functions
* @author    	조대기(2008 Global Intern ���)				박현(IL3용으로 수정)
* @date         2008/07/17
*/

/************************************************************************
Google Suggest XML request URL
	http://www.google.com/complete/search?output=toolbar&q=
YouTube Suggest XML request URL
	http://suggestqueries.google.com/complete/search?ds=yt&xml=true&q=
************************************************************************/
var google_suggest_url = 'http://suggestqueries.google.com/complete/search?ds=yt&xml=true&q=';

//XmlHttpRequest object to get the auto suggest
var searchReq = getXmlHttpRequestObject();

//Variables
var index;
var current_index;		//Result box focus index
var last_input;				
var list;
/**
 * @brief			Gets the browser specific XML Http Request  Object
 * @remarks		Gets the browser specific XmlHttpRequest Object
 * @return 		void
*/
function getXmlHttpRequestObject() {
    if (window.XMLHttpRequest) {
        return new XMLHttpRequest();
    } else if(window.ActiveXObject) {
        return new ActiveXObject("Microsoft.XMLHTTP");
    } else {
        TRACE("Your browser does not support XMLHTTP.");
    }
}

/**
 * @brief			Move focus
 * @remarks		By calling these functions, move up and down among the searched results in the result box
 * @return 		void
*/
function display_searchbox_up(){
	TRACE("display_searchbox_up")
	var inputValue = document.getElementById("searchText1").value;
	if(inputValue.length ==0 ){
		TRACE("Input string is null!!")
		return;	
	}
	if(list == null || list.length == 0)
		return;

	var ss = document.getElementById(current_index);
	if (ss != null) {
		ss.style.backgroundColor = "transparent";
		ss.style.backgroundImage = "url(none)"; 
	}		

	current_index--;
	
	if ( current_index == -2){
		current_index = index-1;
		if( totalListPage > 1) {
			var i = 0;
			var ss = document.getElementById('search_suggest');
			ss.innerHTML = '';
			for(i = 5;  i<list.length; i++){
				word = list[i].attributes[0].nodeValue;
				
				var suggest = '<div id = "'+ i + '" ';
			  	suggest += 'onclick="javascript:setSearch(this.firstChild.innerHTML);" ';
			  	suggest += 'class="suggest_link">';
			  	suggest += '<span class="suggest_word">' + word + '</span>';
			 	suggest += '</div>';
				
				ss.innerHTML += suggest;				
			}	
			moveSuggestDrag("down");
		}		 
	}
	
	if( current_index == 4) {
		var i = 0;
		var ss = document.getElementById('search_suggest');
		ss.innerHTML = '';
		for(i = 0;  i<list.length; i++){
			word = list[i].attributes[0].nodeValue;
						
			var suggest = '<div id = "'+ i + '" ';
		  	suggest += 'onclick="javascript:setSearch(this.firstChild.innerHTML);" ';
		  	suggest += 'class="suggest_link">';
		  	suggest += '<span class="suggest_word">' + word + '</span>';
		 	suggest += '</div>';
		  	
		  	ss.innerHTML += suggest;
		} 
		moveSuggestDrag("up");
	} 
	TRACE("current_index :: "+current_index)
	ss = document.getElementById(current_index);
	if (ss != null){
		ss.style.background = "url(img/sub2_search_box9_s.png)";
		tmpStr = removeNL(ss.firstChild.innerHTML);
		
		//document.getElementById('searchText1').value = tmpStr;
//		imeSetString(document.getElementById("searchText1"), tmpStr);
		ime.setString(tmpStr);	
	}
	else
		//document.getElementById('searchText1').value = last_input; 
//		imeSetString(document.getElementById("searchText1"), last_input);
		ime.setString(last_input);
}

function display_searchbox_down(){
	TRACE("display_searchbox_down")
	var inputValue = document.getElementById("searchText1").value;
	if(inputValue.length ==0 ){
		TRACE("Input string is null!!")
		return;	
	}
	if(list == null || list.length == 0)
		return;		
	var ss = document.getElementById(current_index);
	if (ss != null) {
		ss.style.backgroundColor = "transparent";
		ss.style.backgroundImage = "url(none)"; 
	}	
	
	current_index++;
	if ( current_index == index ) {
		current_index = -1;
		var i = 0;
		var ss = document.getElementById('search_suggest');
		ss.innerHTML = '';
		for(i = 0;  i<list.length; i++){
			word = list[i].attributes[0].nodeValue;
						
			var suggest = '<div id = "'+ i + '" ';
		  	suggest += 'onclick="javascript:setSearch(this.firstChild.innerHTML);" ';
		  	suggest += 'class="suggest_link">';
		  	suggest += '<span class="suggest_word">' + word + '</span>';
		 	suggest += '</div>';
		  	
		  	ss.innerHTML += suggest;
		} 
		moveSuggestDrag("up");
	}
	if( current_index == 5) {
		var i = 0;
		var ss = document.getElementById('search_suggest');
		ss.innerHTML = '';
		for(i = current_index;  i<list.length; i++){
			word = list[i].attributes[0].nodeValue;
						
			var suggest = '<div id = "'+ i + '" ';
		  	suggest += 'onclick="javascript:setSearch(this.firstChild.innerHTML);" ';
		  	suggest += 'class="suggest_link">';
		  	suggest += '<span class="suggest_word">' + word + '</span>';
		 	suggest += '</div>';
		  	
		  	ss.innerHTML += suggest;
		} 
		moveSuggestDrag("down");
	}
	TRACE("current_index :: "+current_index)
	ss = document.getElementById(current_index);
	if (ss != null){
		ss.style.background = "url(img/sub2_search_box9_s.png)";
		tmpStr = removeNL(ss.firstChild.innerHTML);
		
		//document.getElementById('searchText1').value = tmpStr;
//		imeSetString(document.getElementById("searchText1"), tmpStr);		
		ime.setString(tmpStr);
	}
	else
		//document.getElementById('searchText1').value = last_input; 
//		imeSetString(document.getElementById("searchText1"), last_input);
		ime.setString(last_input);
}


/**
 * @brief			Google suggest initializing function
 * @remarks		Request suggestions to google with input string
 * @return 		void
*/
function searchSuggest(keyEvent) {
	alert("searchSuggest :: "+keyEvent);
	if (searchReq.readyState == 4 || searchReq.readyState == 0) {
		var str = escape(document.getElementById('searchText1').value);
		TRACE("before escape :: " +document.getElementById('searchText1').value)
		TRACE("str :: "+ str);
		searchReq.open("GET", google_suggest_url + document.getElementById('searchText1').value, true);
		searchReq.onreadystatechange = handleSearchSuggest; 
		searchReq.send(null);
	}	
}

/**
 * @brief			Display function
 * @remarks		Called when the AJAX response is returned.
 							Display returned results in the result box
 * @return 		void
*/
function handleSearchSuggest() {
	alert("searchReq.readyState :: "+searchReq.readyState)
    if (searchReq.readyState == 4 && searchReq.status == 200) {
    	var ss = document.getElementById('search_suggest');
        var xmlDoc=searchReq.responseXML; //get response
        list = xmlDoc.getElementsByTagName('suggestion');
        var list2 = xmlDoc.getElementsByTagName('num_queries');

		current_index = -1;
		index = list.length;
		
		last_input = document.getElementById('searchText1').value;
		
		suggsetListNum = list.length;
		totalListPage = Math.ceil(suggsetListNum/showNumofSuggestPage);
	
		TRACE("totalListPage :: "+totalListPage)
				
		if (list.length == 0){
			hideGoogleSuggest();
		}else{
			showGoogleSuggest();			
		}
		ss.innerHTML = '';
		TRACE("list.length ::  "+list.length)
		for(i = 0;  i<list.length; i++){
			word = list[i].attributes[0].nodeValue;
						
			var suggest = '<div id = "'+ i + '" ';
		  	suggest += 'onclick="javascript:setSearch(this.firstChild.innerHTML);" ';
		  	suggest += 'class="suggest_link">';
		  	suggest += '<span class="suggest_word">' + word + '</span>';
		 	suggest += '</div>';
		  	
		  	ss.innerHTML += suggest;
		} 
		
    }
    else{
    	document.getElementById('search_suggest').innerHTML = '';
    	hideGoogleSuggest();
    }
}

function clearGoogleSuggestList(){
	alert("searchReq xhr abort");
	searchReq.abort();
	if(searchReq != null){
		searchReq.destroy();
		searchReq = null;
		setTimeout(function(){
			searchReq = getXmlHttpRequestObject();		
		},500);		
	}	
	document.getElementById('search_suggest').innerHTML = '';
	hideGoogleSuggest();	
}

function showGoogleSuggest(){
	document.getElementById('search_suggest').style.visibility = "visible";
//	document.getElementById('searchPopupLineDown').style.visibility = "hidden";
	if( totalListPage > 1 ) {
		showSuggestScroll();	
	}
}

function hideGoogleSuggest(){
	document.getElementById('search_suggest').style.visibility = "hidden";
	document.getElementById('searchPopupLineDown').style.visibility = "visible";
	hideSuggestScroll();
}

//Function to remove new line or tab
function removeNL(s){ 
  return s.replace(/[\n\r\t]/g,""); 
}

//Click function
function setSearch(value) {
    document.getElementById('searchText1').value = value;
    document.getElementById('search_suggest').innerHTML = '';
    hideGoogleSuggest();
}

/**
 * @brief		    suggest scroll show 함수
 * @remarks	
 * @param		void		
 * @return	 	void
*/
function showSuggestScroll() {
	document.getElementById("suggest_drag").style.top="0px";
	document.getElementById("search_suggest_scroll").style.visibility ="visible";
}

/**
 * @brief		    suggest scroll hide 함수
 * @remarks	
 * @param		void		
 * @return	 	void
*/
function hideSuggestScroll() {
	document.getElementById("search_suggest_scroll").style.visibility ="hidden";
}

function moveSuggestDrag(position) {
	switch ( position ) {
		case "up" :
			document.getElementById("suggest_drag").style.top= "0px";
			break;
		case "down" :
			document.getElementById("suggest_drag").style.top= "135px";
			break;
		
		default :
			break;		
	}	
}