
var VINFO_FILM = 'film',
VINFO_SERIAL = 'serial',
VINFO_ADV = 'reklama';

var vinfo = {
    id: null,
    // (vinfo_type_film|vinfo_type_serial)
    type: null,
    misc: null    
}

vinfo.init_from_SearchObj = function() {
    var item = new Object();
    item.id = Search[active_res].id;    
    item.type = Search[active_res].type;
    item.misc = Search[active_res];    
    return item;
}

vinfo.init_from_VideoInfoObj = function() {
    var item = new Object();
    item.id = VideoUrl.id;            
    item.type = VINFO_FILM;
    item.misc = VideoInfo;    
    return item;
}

vinfo.init_from_CompInfoObj = function() {
    var item = new Object();
    item.id = VideoUrl.id;            
    item.type = VINFO_SERIAL;
    item.misc = CompInfo[current_siason_no].episode[current_episode];
    return item;
}

vinfo.init_from_AdvObj = function() {
    var item = new Object();
    item.id = AdvUrl.id
    item.type = VINFO_ADV;
    item.misc = AdvUrl;
    return item;
}

var Player =
{    
    stateTimer: null, 
    curPos: 0,
    is_contols_locked: false,
    vinfo: null,
    mem: 
	{
        vinfo: null, 
        video_pos: 0, 
        url: null
    },
    plugin : null,
    state : -1,
    skipState : -1,
    stopCallback : null,    /* Callback function to be set by client */
    originalSource : null,
    
    STOPPED : 0,
    PLAYING : 1,
    PAUSED : 2,  
    FORWARD : 3,
    REWIND : 4,
    LOFORWARD : 5,
    LOREWIND : 6,
    /**
     * что-то с перемоткой на 30 сек. (Player.smart_backward() � Player.smart_forward())
     */
    SMALL_VIDEO_LEN: 180,

    END_OF_ADV: 0.99,
    go_to_pos: 0,	
    STEP: 3000
}

Player.set_vinfo = function(vinfo) {
    this.vinfo = vinfo    
}

Player.init = function()
{
    var success = true;
    this.vinfo = null;
    //alert("success vale :  " + success);
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");
    
    if (!this.plugin)
    {
        //alert("success vale this.plugin :  " + success);
        success = false;
    }
    
    //alert("success vale :  " + success);    
    
    this.setFullscreen();
	
    //alert("success vale :  " + success);    
    
    this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.plugin.OnStreamInfoReady = 'Player.onStreamInfoReady';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';  
    /// errors handlers
    this.plugin.OnConnectionFailed = 'Player.OnConnectionFailed';
    this.plugin.OnNetworkDisconnected = 'Player.OnNetworkDisconnected';
    this.plugin.OnRenderError = 'Player.OnRenderError';
    this.plugin.OnStreamNotFound = 'Player.OnStreamNotFound';
    
    this.plugin.OnRenderingComplete = player_on_render_end;             
            
    //alert("success vale :  " + success);       
    return success;
}

function player_on_render_end ()
{
    clearTimeout(plashkaTimer);
    plashkaTimer = null;
	
    Player.onItemEnd();
}

Player.deinit = function()
{
    //alert("Player deinit !!! " );       
      
    if (this.plugin)
    {
        this.plugin.Stop();
    }
}

Player.setWindow = function()
{
    this.plugin.SetDisplayArea(0, 0, 472, 270);
}

Player.setFullscreen = function()
{
    this.plugin.SetDisplayArea(0, 0, 960, 540);
}

// @param url string
Player.setVideoURL = function(url)
{    
    this.url = url;
}

function player_check_state() 
{
    if ( (Player.curPos >= Math.round(Display.totalTime - 2000) / 1000) ) 
    {
        Player.stopVideo();
        clearInterval(Player.stateTimer);
        Player.stateTimer = null;
        Player.onItemEnd();
    }
}

Player._onBeforePlay = function() 
{
    stepTimer();
	//stepTimer(true);
    this.curPos = 0;    
    //Visual.HidePreloader();
    this.state = this.PLAYING;
    $("#play").addClass("pause");
    this.setFullscreen();
}

Player.playVideo = function()
{       
    //  alert('type=' + this.vinfo.type + 'Player.playVideo() url: ' + this.url  )
    if (this.url == null)
    {
    //alert("No videos to play");
    }
    else
    {        
        Player._onBeforePlay();
        this.plugin.Play(this.url);
    }
}

Player.pauseVideo = function()
{   
    this.state = this.PAUSED;
    //Display.status("Pause");
    $("#play").removeClass("pause");
    this.plugin.Pause();
}

Player.stopVideo = function()
{   
    if (this.state != this.STOPPED)
    {
        this.state = this.STOPPED;
        //Display.status("Stop");
        if (this.plugin != null) // ����������� ���������
            this.plugin.Stop(); 
        Display.flush();
        
        if (this.stopCallback)
        {
            this.stopCallback();
        }
    }
    else
    {
        alert("Ignoring stop request, not in correct state");
    }
}

Player.resumeVideo = function()
{
    this.state = this.PLAYING;
    //Visual.HidePreloader();
    //Display.status("Play");
    this.plugin.Resume();
}

Player.skipStepForwardVideo = function()
{
    this.skipState = this.FORWARD;
    this.plugin.JumpForward(this.STEP);
    this.STEP = 0;
}

Player.skipStepBackwardVideo = function()
{
    this.skipState = this.REWIND;
    this.plugin.JumpBackward(this.STEP);
    this.STEP = 0;
}

Player.skipForwardVideo = function()
{
    this.skipState = this.FORWARD;
    this.plugin.JumpForward(180);    
}

Player.skipBackwardVideo = function()
{
    this.skipState = this.REWIND;
    this.plugin.JumpBackward(180);    
}

Player.skipLoForwardVideo = function()
{
    this.skipState = this.LOFORWARD;
    this.plugin.JumpForward(30);
}

Player.skipLoBackwardVideo = function()
{
    this.skipState = this.LOREWIND;
    this.plugin.JumpBackward(30);
}

Player.getState = function()
{
    return this.state;
}

Player.smart_jump = function(pos_sec) 
{
    var delta = this.curPos  - pos_sec;    
    if (delta > 0) {
        this.plugin.JumpBackward(delta);        
    }
    else {
        this.plugin.JumpForward(Math.abs(delta));        
    }    
}

Player.get_play_time_sec = function() 
{
    return Math.floor(Player.plugin.GetDuration() / 1000);
}

Player.smart_backward = function() 
{
    if (this.get_play_time_sec() > this.SMALL_VIDEO_LEN)
        this.skipBackwardVideo();
    else
        this.skipLoBackwardVideo();
}

Player.smart_forward = function() 
{     
    if (this.get_play_time_sec() > this.SMALL_VIDEO_LEN)
        this.skipForwardVideo();
    else
        this.skipLoForwardVideo();
}

Player.onBufferingStart = function()
{    
    Visual.ShowPreloader(false);
}

Player.onBufferingProgress = function(percent)
{
	//Display.status("Buffering:" + percent + "%");
}

Player.onBufferingComplete = function()
{
}

var ShowAdvOne = false;

/**
 * @param pos_sec int вот кажется этот в секундах
 */
Player.go_to_sec = function(pos_sec) {
    this.go_to_pos = pos_sec;    
    this.playVideo();
}

/**
 * @prarm url string
 * @param pos_sec int ������� � ��������
 * WARN: ���� Player.vinfo ������ ���� ��������� �����������!
 */
Player.start_play_item = function (url, pos_sec) 
{
    if (this.vinfo.type != VINFO_ADV && AdvUrl.type == 'preroll' && !AdvUrl.played) 
    {        
        this.is_contols_locked = true;
        this.mem.vinfo = this.vinfo;
        this.mem.url = url;
        if (pos_sec != null)
            this.mem.video_pos = pos_sec;
        my.onAdvStart(this.vinfo.id, AdvUrl.id);
        this.url = AdvUrl.url_hi;
        this.set_vinfo( vinfo.init_from_AdvObj() );               
        this.playVideo();
    }
    else 
    {
        this.url = url
        if (pos_sec != null)
            this.go_to_sec(pos_sec)
        else 
            this.playVideo()
    }
}

Player.show_postroll_adv = function() 
{    
    if (this.vinfo.type != VINFO_ADV && AdvUrl.type == 'postroll' && !AdvUrl.played) 
	{                
        this.is_contols_locked = true;
        this.plugin.Stop();
        this.mem.vinfo = this.vinfo;        
        this.mem.url = this.url;
        this.mem.video_pos = this.curPos;
        my.onAdvStart(this.vinfo.id, AdvUrl.id);
        this.url = AdvUrl.url_hi;
        this.set_vinfo( vinfo.init_from_AdvObj() );
        this.playVideo();
    }
}

Player.onItemEnd = function() 
{
    switch (this.vinfo.type) 
    {
        case VINFO_ADV:
            if (!AdvUrl.played) 
            {        
                switch (AdvUrl.type) 
                {
                    case "preroll":
                    case "postroll":
                        Visual.ShowPreloader(false);
                        Player.stopVideo();
                        AdvUrl.played = true;
                        this.vinfo = this.mem.vinfo;
                        this.url = this.mem.url;                        
                        this.is_contols_locked = false
                        if (this.mem.video_pos != null && this.mem.video_pos != 0)
                            this.go_to_sec(this.mem.video_pos);
                        else
						{
							if (AdvUrl.type == "postroll")
							{
					            Visual.ShowPreloader(true);
					            Player.stopVideo();
					            if (this.vinfo.type == VINFO_SERIAL)
					                my_action = NAME_COMPILATION;
					            else
					                my_action = NAME_PREVIEW;
					            my_action_prev = NAME_MENU_CAT_GEN;
					            clearTimeout(plashkaTimer);
					            plashkaTimer = null;
					            $("#container").show();
					            myEvent.gotoUrl(my_action);
					            setTimeout(Visual.HidePreloader, 2000);
								return;
							}
							this.playVideo();
						}
                        return;              
                    break;            
                    default:
                    break;
                //wtf???
                }
            }
            break;
        case VINFO_FILM:
        case VINFO_SERIAL:
            Visual.ShowPreloader(true);
            Player.stopVideo();
            if (this.vinfo.type == VINFO_SERIAL)
                my_action = NAME_COMPILATION;
            else
                my_action = NAME_PREVIEW;
            my_action_prev = NAME_MENU_CAT_GEN;
            clearTimeout(plashkaTimer);
            plashkaTimer = null;
            $("#container").show();
            myEvent.gotoUrl(my_action);
            setTimeout(Visual.HidePreloader, 2000);
            return;
		break;
    }
}

Player.setCurTime = function(time)
{   

	// показать муту, если она есть
	if (Audio.isMute)
	{
		Audio.plugin.SetSystemMute(true);
		Display.setMute();
	}
	else
	{
		Audio.plugin.SetSystemMute(false);
		Display.unsetMute();
	}
		

    //if (this.stateTimer == null) this.stateTimer = setInterval(player_check_state, 500);
    
    this.curPos = Math.floor( time / 1000 );    
    Visual.HidePreloader();
    
    if (this.go_to_pos != 0) 
    {
        var val = this.go_to_pos;
        this.go_to_pos = 0;
        this.smart_jump(val)        
    } 
    if (this.vinfo.type == VINFO_ADV)
    {
        var t = Display.totalTime - time;
        Display.setTime(t);
        $("#timeInfo").addClass("onmark");
    }
    else
    {
        Display.setTime(time);
        $("#timeInfo").removeClass("onmark");
    } 
	
    if (this.vinfo.type != VINFO_ADV && time >= parseInt(Display.totalTime) * 0.97) 
    {
        Player.show_postroll_adv();
    }
}

Player.onStreamInfoReady = function()
{
    Display.setTotalTime(Player.plugin.GetDuration());    
}

stopPlayer = function()
{
    Player.stopVideo();
}

setTottalBuffer = function(buffer) {
    alert("setTottalBuffer " + buffer);
}

setCurBuffer = function(buffer) {
    alert("setCurBuffer " + buffer);
}

/**
 * Общий обработчик ошибок
 * @param msg необязательный текст ошибки
 */
Player.on_shit_happens = function(msg) 
{
    try 
	{        
        if (!msg) 
		{
            msg = "Произошла непредвиденная ошибка, приносим свои извинения.";
        }
        alert("Player.on_shit_happens(): " + msg)        
        this.plugin.Stop(); 
        Display.flush();
        Visual.HidePreloader();
        my_action = NAME_REPORT;
        myEvent.gotoUrl(my_action)
        Visual.ShowReportWindow(msg);
    } 
	catch(e) 
	{
    	//вот тут уже конкретная жопа случилась, и чего делать неясно
    }
}

Player.OnConnectionFailed = function() 
{
    this.on_shit_happens("Ошибка подключения к серверу, возможно, он перегружен, попробуйте позднее.");
}

Player.OnNetworkDisconnected = function() 
{
    this.on_shit_happens("Произошло отключение от сети, возможно, за долги :-)");
}

Player.OnRenderError = function() 
{
    this.on_shit_happens("Ошибка обработки видео, приносим свои извинения.");
}

Player.OnStreamNotFound = function() 
{
    this.on_shit_happens("Ошибка обработки видео, пожалуйста, выберите другой фильм");
}
    