﻿// файл со структурой данных

var getInfo = {}
var setInfo = {
	// константы-имена элементов
	CAT_NAME: "cat", // название ИД для категорий
	FILTER_NAME: "filter", // название ИД для всех фильтров (страны, года, жанры)
	CON_NAME: "con", // название ИД для контента
	MAX_DIRECTORS: 8, // максимальное количество режисеров
	MAX_ITEMS_ON_: 7, // максимальное количество элементов на выпадашке с годами, жанрами и странами
	EMPTY_IMAGE: "img/ivi-video-default_preview.png", //путь к заглушке
	MAX_DESCRIPTION_LENGTH: 450,//максимальное количество символов в описании
	MAX_MINI_SERIES_LIST: 2 // максимальное количество серий в правом меню на странице описания сериала
}
var Visual = {
	ul_pos: new Array()
}
var Navigator = {}
var myEvent = {}

var VK  = "vk";
var FB  = "fb";
var TWT = "twt";
var IVI = "ivi";
var YA  = "ya";

var id_user = -1000;
var soc_type = IVI;
var user_name = "";

// константы неактивных и погашенных элементов
var NOT_ACTIVE = -1000;
var ACTION_NONE = "none";
var ALL_ELEM = 123456; // выбор - "любой"

var MAX_PROMOS = 4;
var MAX_LINE_CONTENTS = 5;
var VERY_MUCH_CONTENT = 19;
var PROMOS_INTERVAL = 10000; //интервал обновления промо, в миллисекундах
var MAX_VISIBLE_LINES_ON_CATEGORY = 2; //максимальное количество рядов картинок в категории
var MAX_VISIBLE_LINES_ON_MAIN = 1; //максимальное количество рядов картинок на главной
var MAX_LENGTH_TITLE_IN_SERIES_LIST = 10; //максимальная длина заголовка серии в списке серий в описании сборника
var PLASHKA_TIMER = 4000; //количество сек, через которое плашка управления видео скрывается, если пользователь не нажимает на кнопки
var plashkaTimer = null; //таймер, который показывает или скрывает плашку управления видео
/**
 * количество сек, через которое скроется регулятор громкости
 */
var VOLBAR_TIMER = 2000;
/**
 * таймер, который показывает или скрывает регулятор громкости
 */
var volbarTimer = null;


// названия вьюх и партиалов
var NAME_MENU_CAT_GEN = "menu_cat_gen";
var NAME_CONTENT = "content";
var NAME_PREVIEW = "preview";
var NAME_SERIAL = "serial"; //страница списка серий
var NAME_COMPILATION = "compilation"; //страница описания сериала
var NAME_PLAYER = "player";
var NAME_ARTIST = "artist";
var NAME_SEEK = "seek";
var NAME_ALLRESULTS = "all_results";
var NAME_AUTORISATION = "autorisation";
var NAME_SELECT_GENRE_COUNT_YEAR = "select_gen_count_year";
var NAME_SELECT_YEAR = "select_year";
var NAME_NTF = "ntf_window"; //окно Вам уже есть 18 лет?
var NAME_SELECT_SEASON = "select_season";
var NAME_NOT_IN_RUSSIA = "not_in_russia";
var NAME_RECENSION = "recension";
var NAME_SELECT_AUTORISATION = "select_auto";
var NAME_REPORT = "report_window";
var NAME_FAVORITES = "user_favorites";

var my_action = ACTION_NONE; // указатель,в какой вьюхе сидим
var my_action_prev = ACTION_NONE; // указатель,в какой вьюхе были до начала просмотра
var my_action_goto_main = ACTION_NONE; // указатель на обратную страницу (с превью фильма или сборника)

// массивы данных
var Country = new Array(); // массив стран
var Category = new Array(); // список категорий
var Promo    = new Array(); // список промо
var elem     = new Array(); // массив элементов блока с масками фильтра



var VideoInfo = null; // информация о фильме
var CompInfo = new Array(); // информация о сборнике (потому что он присылает инфу сразу о всех сериях)

var ContentPop = new Array(); // список самого популярного контента
var ContentNew = new Array(); // список новинок контента

var ReqCount = 0;
var STEP_MORE_CONTENT = 10;

var filterCountry = NOT_ACTIVE; // выбранный фильтр по стране
var filterYear    = NOT_ACTIVE; // выбранный фильтр по году
var filterGenre   = NOT_ACTIVE; // выбранный фильтр по жанру
// новый фильтр для годов 
var year_from = NOT_ACTIVE;
var year_to = NOT_ACTIVE;


var nameCountry = NOT_ACTIVE; // название выбранной страны
var nameGenre   = NOT_ACTIVE; // название выбранного жанра

var VideoUrl = null; // ссылка на фильм и мидролы
var AdvUrl = null; // ссылка на рекламный ролик

var Favorite = {vid: new Array(), comp: new Array()}; // избранное пользователя

var NAME_COOKIE = "name_";
var VAL_COOKIE = "1";

var NextEp = null; // ссылка на следующий эпизод (координаты в массиве)

var Recension = new Array();
var Search = new Array();
var T9 = new Array();

var isBlockKeys = false;
var isBlockRecBut = true; // блокировка кнопки с рецензиями

// константа, чтобы показать все элементы на главной
var ShowMain = 0;


// поставить куку
function setCookie (name, value, expires, path, domain, secure)
{
    document.cookie = name + "=" + escape(value) +
                    ((expires) ? "; expires=" + expires : "") +
                    ((path) ? "; path=" + path : "") +
                    ((domain) ? "; domain=" + domain : "") +
                    ((secure) ? "; secure" : "");
}

// прочитать куку
function getCookie(name)
{
    var cookie = " " + document.cookie;
    var search = " " + name + "=";
    var setStr = null;
    var offset = 0;
    var end = 0;
    if (cookie.length > 0)
    {
        offset = cookie.indexOf(search);
        if (offset != -1)
        {
            offset += search.length;
            end = cookie.indexOf(";", offset)
            if (end == -1)
            {
                end = cookie.length;
            }
            setStr = unescape(cookie.substring(offset, end));
        }
    }
    return(setStr);
}

// получить следующую серию к просмотру (считается, что у нас только сборник)
function getNextEpisode()
{
	var res = {season: 0, episode: 0};

	for (var i = 0; i < CompInfo.length; i++)
	{
		for (var j = 0; j < CompInfo[i].episode.length; j++)
		{
			var ck = getCookie(NAME_COOKIE + CompInfo[i].episode[j].id);
			if (ck == VAL_COOKIE)
			{
				if (j > 0)
				{
					res.season = i;
					res.episode = j - 1;
					return res;
				}
				else
				{
					if (i > 0)
					{
						res.season = i - 1;
						res.episode = CompInfo[i - 1].episode.length - 1;
						return res;
					}
				}
			}
		}
	}
	return res;
}

// получить идентификатор эпизода из CompInfo
function getIdEpisode(no, type)
{
	var len = 0;
	for (var i = 0; i < CompInfo.length; i++)
	{
		if (CompInfo[i].episode.length > no) // все заебись, можно писать
		{
            if (type == "id")
			    return CompInfo[i].episode[no - len].id;
            else
                return CompInfo[i].episode[no - len].title;
		}
		else // сука, попался короткий сезон!
		{
			len += CompInfo[i].episode.length;
		}
	}
    if (type == "id")
	    return CompInfo[0].episode[0].id;
    else
        return CompInfo[0].episode[0].title;
}


// объект для работы с символами и вводом с пульта
Alf = {
	T9keys: "", // строка с циферными значениями, которые отдаются в в запрос
	T9words: new Array(), // массив со словами для Т9
	T9on: "t9 вкл",
	T9off: "t9 выкл",
    RUS_S: "Rus_S",
    ENG_S: "Eng_S",
    RUS_B: "Rus_B",
    ENG_B: "Eng_B",
    SPEC: "Spec",
	// алфавиты
	Codes: {Rus_S: new Array(),
			Eng_S: new Array(),
			Rus_B: new Array(),
			Eng_B: new Array(),
            Spec: new Array()},
	CODE_TIMER: 1000, // время, через которое символ допишется
	codeTimer: null, // таймер, который определяет вставку символа

	curCode: "",
	posSymbol: 0, // текущая позиция символа

	mode: "Rus_S", // в какой массив смотрим
	modeT9: "t9 выкл" // текущий режим ввода (т9 включен или выключен)
}

// расположить символы в массиве
Alf.setCodesSymbols = function ()
{
	Alf.Codes.Rus_S[0] = {Elem: "0", Val: " "};
	Alf.Codes.Rus_S[1] = {Elem: "1", Val: "1"};
	Alf.Codes.Rus_S[2] = {Elem: "2", Val: "абвг2"};
	Alf.Codes.Rus_S[3] = {Elem: "3", Val: "деёжз3"};
	Alf.Codes.Rus_S[4] = {Elem: "4", Val: "ийкл4"};
	Alf.Codes.Rus_S[5] = {Elem: "5", Val: "мноп5"};
	Alf.Codes.Rus_S[6] = {Elem: "6", Val: "рсту6"};
	Alf.Codes.Rus_S[7] = {Elem: "7", Val: "фхцч7"};
	Alf.Codes.Rus_S[8] = {Elem: "8", Val: "шщъы8"};
	Alf.Codes.Rus_S[9] = {Elem: "9", Val: "ьэюя9"};

	Alf.Codes.Eng_S[0] = {Elem: "0", Val: " "};
	Alf.Codes.Eng_S[1] = {Elem: "1", Val: "1"};
	Alf.Codes.Eng_S[2] = {Elem: "2", Val: "abcd2"};
	Alf.Codes.Eng_S[3] = {Elem: "3", Val: "efgh3"};
	Alf.Codes.Eng_S[4] = {Elem: "4", Val: "ijk4"};
	Alf.Codes.Eng_S[5] = {Elem: "5", Val: "lmn5"};
	Alf.Codes.Eng_S[6] = {Elem: "6", Val: "opq6"};
	Alf.Codes.Eng_S[7] = {Elem: "7", Val: "rst7"};
	Alf.Codes.Eng_S[8] = {Elem: "8", Val: "uvw8"};
	Alf.Codes.Eng_S[9] = {Elem: "9", Val: "xyz9"};

	Alf.Codes.Rus_B[0] = {Elem: "0", Val: " "};
	Alf.Codes.Rus_B[1] = {Elem: "1", Val: "1"};
	Alf.Codes.Rus_B[2] = {Elem: "2", Val: "АБВГ2"};
	Alf.Codes.Rus_B[3] = {Elem: "3", Val: "ДЕЁЖЗ3"};
	Alf.Codes.Rus_B[4] = {Elem: "4", Val: "ИЙКЛ4"};
	Alf.Codes.Rus_B[5] = {Elem: "5", Val: "МНОП5"};
	Alf.Codes.Rus_B[6] = {Elem: "6", Val: "РСТУ6"};
	Alf.Codes.Rus_B[7] = {Elem: "7", Val: "ФХЦЧ7"};
	Alf.Codes.Rus_B[8] = {Elem: "8", Val: "ШЩЪЫ8"};
	Alf.Codes.Rus_B[9] = {Elem: "9", Val: "ЬЭЮЯ9"};

	Alf.Codes.Eng_B[0] = {Elem: "0", Val: " "};
	Alf.Codes.Eng_B[1] = {Elem: "1", Val: "1"};
	Alf.Codes.Eng_B[2] = {Elem: "2", Val: "ABCD2"};
	Alf.Codes.Eng_B[3] = {Elem: "3", Val: "EFGH3"};
	Alf.Codes.Eng_B[4] = {Elem: "4", Val: "IJK4"};
	Alf.Codes.Eng_B[5] = {Elem: "5", Val: "LMN5"};
	Alf.Codes.Eng_B[6] = {Elem: "6", Val: "OPQ6"};
	Alf.Codes.Eng_B[7] = {Elem: "7", Val: "RST7"};
	Alf.Codes.Eng_B[8] = {Elem: "8", Val: "UVW8"};
	Alf.Codes.Eng_B[9] = {Elem: "9", Val: "XYZ9"};

    Alf.Codes.Spec[0] = {Elem: "0", Val: ".,:;"};
    Alf.Codes.Spec[1] = {Elem: "1", Val: "!\"'"};
    Alf.Codes.Spec[2] = {Elem: "2", Val: "@"};
    Alf.Codes.Spec[3] = {Elem: "3", Val: "#№"};
    Alf.Codes.Spec[4] = {Elem: "4", Val: "$"};
    Alf.Codes.Spec[5] = {Elem: "5", Val: "%"};
    Alf.Codes.Spec[6] = {Elem: "6", Val: "^+-"};
    Alf.Codes.Spec[7] = {Elem: "7", Val: "&/"};
    Alf.Codes.Spec[8] = {Elem: "8", Val: "*[]"};
    Alf.Codes.Spec[9] = {Elem: "9", Val: "(){}"};
}

// вернуть следующий символ по известному режиму и элементу массива
Alf.getNextSymbol = function (curSym, num_elem)
{
	var Mas = null;
	switch (Alf.mode)
	{
        case Alf.RUS_S:
            Mas = Alf.Codes.Rus_S[num_elem].Val;
        break;
        case Alf.ENG_S:
            Mas = Alf.Codes.Eng_S[num_elem].Val;
        break;
        case Alf.RUS_B:
            Mas = Alf.Codes.Rus_B[num_elem].Val;
        break;
        case Alf.ENG_B:
            Mas = Alf.Codes.Eng_B[num_elem].Val;
        break;
        case Alf.SPEC:
            Mas = Alf.Codes.Spec[num_elem].Val;
        break;
	}
	if (curSym != "" && curSym != null && curSym != undefined)
	{
		if (Mas.indexOf(curSym) < Mas.length - 1)
			return Mas[Mas.indexOf(curSym) + 1];
		else
			return Mas[0];
	}
	else
		return Mas[0];
}

Alf.pasteSymbol = function (symbol, input_name)
{
	var res = $("." + input_name).text();
    res = res.substring(0, res.length - 1); // отрезать последний символ от строки
	$("." + input_name).text(res + symbol);
}

// удалить последний символ в строке
Alf.DelLastSymbol = function (input_name)
{
	var res = $("." + input_name).text();
    res = res.substring(0, res.length - 1);
	$("." + input_name).text(res);
    Alf.posSymbol = res.length;
    clearTimeout(Alf.codeTimer);
}

Alf.stepCodeTimer = function (num_elem, input_name)
{
    if (Alf.codeTimer != null)
		clearTimeout(Alf.codeTimer);
	// заменить текущий символ новым
	var res = $("." + input_name).text();
	if (res == "") // строка ввода пока пустая
	{
		Alf.posSymbol = 0;
		$("." + input_name).text(Alf.getNextSymbol(num_elem, parseInt(num_elem)));
	}
	else // строка не пустая, можно заменять к ебеням символ
	{
		if (Alf.posSymbol >= res.length) // указатель указывает на несуществующий символ. вставить его
		{
			res += Alf.getNextSymbol(num_elem, parseInt(num_elem));
			$("." + input_name).text(res);
		}
		else
        {
			Alf.pasteSymbol(Alf.getNextSymbol(res[Alf.posSymbol], parseInt(num_elem)), input_name);
        }
	}
    Alf.codeTimer = setTimeout(function()
	{
		//Alf.pasteSymbol(Alf.getNextSymbol(res[Alf.posSymbol], parseInt(num_elem)));
		Alf.posSymbol++;
	}, Alf.CODE_TIMER);
}

Alf.setCode = function (num, input_name)
{
	if (Alf.curCode == num) // подставить символ, вместо имеющегося (т.е. последнего)
	{
	    Alf.stepCodeTimer(num, input_name);
	}
	else
	{
	    /// Ежели код текущей клавиши отличается от предыдущего        
	    if (Alf.codeTimer != null) {
	        /// то нафиг нам ждать таймаут на вставку сивола
	        clearTimeout(Alf.codeTimer);                
	    }
	    var res = $("." + input_name).text();
	    
	    if (Alf.posSymbol < res.length) {
	        /// проверка, если таймаут не отработал - то инкрементим позицию
	        Alf.posSymbol++;
	    }
	    Alf.stepCodeTimer(num, input_name);
	    Alf.curCode = num;
	}
}

Alf.pasteT9word = function (input_name, word)
{
	if (T9.length > 0)
	{
		Alf.T9keys += "0"; // дописать ноль в конец маски
		var num = 0;
		for (var i = 0; i < Alf.T9keys.length; i++) // посчитать количество нулей в кодах слов
			if (Alf.T9keys[i] == "0") 
				num++;
		Alf.T9words.length = num; // так он отрежет левое значение
		var str = "";
		if (word == null)
			Alf.T9words[Alf.T9words.length-1] = T9[0]; // в последний элемент массива пишется первое слово из T9
		else
			Alf.T9words[Alf.T9words.length-1] = word; // в последний элемент массива пишется выбранное юзером слово
		for (var i = 0; i < Alf.T9words.length; i++)
		{
			str += Alf.T9words[i] + " ";
		}
		$("." + input_name).text(str);
		T9.length = 0;
		setInfo.placeT9words(); // скрыть выпадашку
	}
}

// получить по коду список слов по запросу на сервак
Alf.setT9Code = function (num, input_name)
{
	if (num == "0" || num == "1") // положить слово и все красиво разместить
	{
		Alf.pasteT9word(input_name, null);
	}
	else // послать запрос на сервак
	{
		Alf.T9keys += num; // дописать элемент в Alf.T9keys
		pos = 0;
		for (var i = 0; i < Alf.T9keys.length; i++)
			if (Alf.T9keys[i] == "0") 
				pos = i;
		if (pos > 0) pos++;
		var val = Alf.T9keys.substr(pos); // то, что шлем на сервер
		getInfo.getT9words(val, (Alf.mode == Alf.RUS_S || Alf.mode == Alf.RUS_B) ? "ru" : "en");
	}
}

// удалить код из строки
Alf.delT9Code = function (input_name)
{
	alert(Alf.T9keys);
	
	var k = Alf.T9keys[Alf.T9keys.length-1];
	if (k == "0" && Alf.T9words.length > 0) // подрезать длину массива
	{
		Alf.T9words.length--;
	}
	if (Alf.T9keys.length > 1)
	{
		Alf.T9keys = Alf.T9keys.substr(0, Alf.T9keys.length-1);
		k = Alf.T9keys[Alf.T9keys.length-1];
		Alf.T9keys = Alf.T9keys.substr(0, Alf.T9keys.length-1);
	}
	if (k != "0") // применить маску
	{
		Alf.setT9Code(k, input_name);
	} 
	
	alert(Alf.T9keys + ", " + k);
}


var Audio =
{
    plugin : null,
	old_vol_level: null,
	isMute: false
}

Audio.init = function()
{
    var success = true;
    this.plugin = document.getElementById("pluginAudio");
    if (!this.plugin)
    {
        success = false;
    }
    return success;
}

Audio.setRelativeVolume = function(delta)
{
    this.plugin.SetVolumeWithKey(delta);    
    Display.setVolume(this.getVolume());
}

Audio.getVolume = function()
{
    //alert("Volume : " +  this.plugin.GetVolume());
    return this.plugin.GetVolume();
}

Audio.trigger_mute = function() 
{
    if (!this.isMute) // тут надо мъютить 
	{
        this.plugin.SetSystemMute(true);
		this.isMute = true;
        Display.setMute();
    } 
	else  // тут надо включать громкость
	{
        this.plugin.SetSystemMute(false);
		this.isMute = false;
		Display.unsetMute();
    }
}


// высрать аналитику на гугл
function setAnalitics(action, opt_label, val)
{
    if (action != null && opt_label != null && val != null)
    {
        _gaq.push(['_trackEvent', action, opt_label, val]);
    }
}