
// получить название страны по id
getInfo.getCountryName = function(id)
{
	for (var i = 0; i < Country.length; i++)
	{
		if (Country[i].id == id)
		{
			return Country[i].title;
		}
	}
	return "страна неизвестна";
}

// получить название категории и название жанра
getInfo.getCatGenreName = function(cat_id, gen_id)
{
	var res = {category_name: "", genre_name: ""};
	if (cat_id != null && gen_id == null) // нужно только название категории
	{
		for (var i = 0; i < Category.length; i++)
		{
			if (Category[i].id == cat_id)
			{
				res.category_name = Category[i].title; 
				return res;
			}
		}
	}
	else // можно вернуть оба названия
	{
		if (gen_id != null) // нужен, по идее, только ИД жанра 
		{
			for (var i = 0; i < Category.length; i++)
			{
				for (var j = 0; j < Category[i].genres.length; j++)
				{
					if (Category[i].genres[j].id == gen_id)
					{
						res.category_name = Category[i].title;
						res.genre_name = Category[i].genres[j].title;
						return res;
					}
				}
			}
		}
	}
	// если просрались ИД-шники
	res.category_name = "no name category";
	res.genre_name = "no name genre";
	return res; 
}

// пробить по айпишнику страну
getInfo.getGeolocation = function()
{
	$.ajax({
		type: "GET",
		url: first_adr + "action=getgeoip", 
		dataType: "json",
		success: function(res)
		{
			if (res.res == "RU" || res.res == "ru")
			{
				Visual.HideMainPage();
								
				getInfo.getCountries(null, null, null, null, null); // заполнить массив со странами
				getInfo.getCategories(); // изначально загружаем список категорий (вместе с жанрами)
			    getInfo.getPromos(0, MAX_PROMOS); // подгружаем промо
			    getInfo.getContent(0, 2*MAX_LINE_CONTENTS-1, null, null, null, "pop", null, null, false, true); // получили популярное на главную
                 $("#novinki").hide();
                ContentNew.length = 0;
			    //getInfo.getContent(0, 2*MAX_LINE_CONTENTS-1, null, null, null, "new", null, null, false); // получили новинки на главную
                my_action = NAME_MENU_CAT_GEN;
				
				activeCat = 0;
				selectCat = 0;
				openCat   = NOT_ACTIVE;
				aciveContent = NOT_ACTIVE;
				
			    myEvent.gotoUrl(my_action); // точка входа в приложение
                Alf.setCodesSymbols();
			}
			else
			{
				myEvent.gotoUrl(NAME_NOT_IN_RUSSIA);
				alert("You have to stay in Russia");
			}
		}
	});
}

// вернуть список стран категории
getInfo.getCountries = function(category_id, genre_id, year_from, year_to, no)
{
	$.ajax({
		type: "GET",
		url: first_adr + "action=getcountries", 
        data: {"category_id": category_id, 
               "genre_id": genre_id, 
               "year_from": year_from, 
               "year_to": year_to},
		dataType: "json",
		success: function(res)
		{
			if (res != null && res.res != null)
			{
	            if (parseInt(no) >= 0) 
				{
					Category[no].countries.length = 0; // обнулить массив
					// стремная заглушка, потому что приходится постфактум заполнять данные в категории
					for (var i = 0; i < res.res.length; i++) 
						Category[no].countries[i] = {id:    res.res[i].id,
													 title: res.res[i].title};
				}
				else 
				{
					for (var i = 0; i < res.res.length; i++) 
						Country[i] = {id: res.res[i].id,
									  title: res.res[i].title};
				}
			}
			else
				alert("null countries");
		}
	});
}

// получить список категорий
getInfo.getCategories = function ()
{
	Category.length = 0; // обнуляем массив
    activeCat = 0; // первая активная - популярное
    selectCat = activeCat;
	$.ajax({
		type: "GET",
		url: first_adr + "action=getcategories", 
		dataType: "json",
		success: function(res)
		{
			if (res != null && res.res != null)
			{
				for (var i = 0; i < res.res.length; i++)
				{
					Category[i] = {genres: res.res[i].genres,
	                               id: res.res[i].id,
	                               title: res.res[i].title, 
	                               countries: new Array(), 
	                               years: null, 
                        years_diap: null
                    };
	                getInfo.getCountries(res.res[i].id, null, null, null, i); // засунуть страны в категорию
	                getInfo.getYears(res.res[i].id, null, null, i); // засунуть года в категорию
				}
				setInfo.placeCategories(); // разместить список категорий на странице
			}
			else
				alert("null categories");
		}
	});
}

// получить список промо
getInfo.getPromos = function(count_from, count_to)
{
    Promo.length = 0; // обнуляем массив
	$.ajax({
		type: "GET",
		url: first_adr + "action=getpromo", 
        data: {"from": count_from, "to": count_to},
		dataType: "json",
		success: function(res)
		{
			if (res != null && res.res != null)
			{
				for (var i = 0; i < res.res.length; i++)
				{
	                Promo[i] = {link: res.res[i].link, // ссылка в никуда (на сайт ivi.ru)
	                            weight: res.res[i].weight, // вес (скорее всего по важности)
	                            title: res.res[i].title, // название
	                            img_iphone: res.res[i].img_iphone, // картинка 640х734
	                            text: res.res[i].text, // текст
	                            content_id: res.res[i].content_id, // ИД контента
	                            img_ipad: res.res[i].img_ipad, // картинка 1024х449
	                            id: res.res[i].id};
				}
			}
			else
				alert("null promo");
			if(Promo.length > 0)
	            setInfo.placePromos(); // разместить список промо на странице
        }
	});
}

// вернуть список годов категории
getInfo.getYears = function(category_id, genre_id, country_id, no)
{
	$.ajax({
		type: "GET",
		url: first_adr + "action=getyears", 
        data: {"category_id": category_id, 
               "genre_id": genre_id, 
               "country_id": country_id},
		dataType: "json",
		success: function(res)
		{
			if (res != null && res.res != null)
			{
	            if (parseInt(no) >= 0)
	            {
	                if (Category[no].years != null) Category[no].years.length = 0; // обнулить массив 
	                Category[no].years = res.res.all_years; // стремная заглушка, потому что приходится постфактум заполнять данные в категории
	                Category[no].years_diap = res.res.diap; // получение диапазонов годов
	            }
	            else
	                return res.res;
			}
			else
				alert("null years");
		}
	});
}

// получить список несериального видео
getInfo.getContent = function(count_from, count_to, country, year_from, year_to, sort, category, genre, isContinue, ShowLoader)
{
	/*
	alert("count_from: " + count_from + ", " + 
		  "count_to: " + count_to + ", " + 
		  "country: " + country + ", " + 
		  "year_from: " + year_from + ", " + 
		  "year_to: " + year_to + ", " + 
		  "sort: " + sort + ", " + 
		  "category: " + category + ", " + 
		  "genre: " + genre + ", " + 
		  "isContinue: " + isContinue);
	*/
	
	if (!isContinue) $(".content").css("visibility", "hidden"); // скрыть нахер отображаемые объекты
	
	if (ShowLoader) Visual.ShowPreloader(true);
	if (!isContinue) // обнуляем массивы, т.е. не догружаем контент
	{
		if (sort == "pop")
	    	ContentPop.length = 0; // обнуляем массив
	    else 
			ContentNew.length = 0; // обнуляем массив
	}
	$.ajax({
		type: "GET",
		url: first_adr + "action=getcontent", 
        data: {"from": count_from, 
               "to": count_to,
               "category": category, 
               "genre": genre, 
               "country": country, 
               "year_from": year_from, 
               "year_to": year_to, 
               "sort": sort},
		dataType: "json",
		success: function(res)
		{
			if (res != null && res.res != null)
			{
				ReqCount = count_to;
				if (!isContinue) // обнуляем массивы, т.е. не догружаем контент
				{

					for (var i = 0; i < res.res.length; i++)
					{
						if (sort == "pop")
						{
							ContentPop[i] = {categories: res.res[i].categories,
											 genres: res.res[i].genres,
											 thumbnails: res.res[i].thumbnails,
											 title: res.res[i].title,
											 country: res.res[i].country,
											 ivi_rating: res.res[i].ivi_rating,
											 kp_rating: res.res[i].kp_rating,
											 imdb_rating: res.res[i].imdb_rating,
											 year: res.res[i].year,
											 descrtiption: res.res[i].descrtiption,
											 id: res.res[i].id,
											 total_contents: res.res[i].total_contents, 
									   		 hru: res.res[i].hru, 
									   		 seasons_count: res.res[i].seasons_count, 
									   		 is_serial: res.res[i].is_serial};
						}
						else
						{
							ContentNew[i] = {categories: res.res[i].categories,
											 genres: res.res[i].genres,
											 thumbnails: res.res[i].thumbnails,
											 title: res.res[i].title,
											 country: res.res[i].country,
											 ivi_rating: res.res[i].ivi_rating,
											 kp_rating: res.res[i].kp_rating,
											 imdb_rating: res.res[i].imdb_rating,
											 year: res.res[i].year,
											 descrtiption: res.res[i].descrtiption,
											 id: res.res[i].id, 
											 total_contents: res.res[i].total_contents, 
									   		 hru: res.res[i].hru, 
									   		 seasons_count: res.res[i].seasons_count, 
									   		 is_serial: res.res[i].is_serial};
						}
		            }
					setTimeout(function(){setInfo.placeContent(sort);}, 2000);
				}
				else // догружаем в хвост массива
				{					
					var max_elem = ContentPop.length;
					if (sort == "pop")
						max_elem = ContentPop.length;
					else
						max_elem = ContentNew.length;
					for (var i = 0; i < res.res.length; i++)
					{
						if (sort == "pop")
						{
							ContentPop[max_elem + i] = {categories: res.res[i].categories,
											 genres: res.res[i].genres,
											 thumbnails: res.res[i].thumbnails,
											 title: res.res[i].title,
											 country: res.res[i].country,
											 ivi_rating: res.res[i].ivi_rating,
											 kp_rating: res.res[i].kp_rating,
											 imdb_rating: res.res[i].imdb_rating,
											 year: res.res[i].year,
											 descrtiption: res.res[i].descrtiption,
											 id: res.res[i].id,
											 total_contents: res.res[i].total_contents, 
									   		 hru: res.res[i].hru, 
									   		 seasons_count: res.res[i].seasons_count, 
									   		 is_serial: res.res[i].is_serial};
						}
						else
						{
							ContentNew[max_elem + i] = {categories: res.res[i].categories,
											 genres: res.res[i].genres,
											 thumbnails: res.res[i].thumbnails,
											 title: res.res[i].title,
											 country: res.res[i].country,
											 ivi_rating: res.res[i].ivi_rating,
											 kp_rating: res.res[i].kp_rating,
											 imdb_rating: res.res[i].imdb_rating,
											 year: res.res[i].year,
											 descrtiption: res.res[i].descrtiption,
											 id: res.res[i].id, 
											 total_contents: res.res[i].total_contents, 
									   		 hru: res.res[i].hru, 
									   		 seasons_count: res.res[i].seasons_count, 
									   		 is_serial: res.res[i].is_serial};
						}
					}
					setInfo.placeMoreContent(sort, max_elem);
					
					var BarHeight = parseInt(ContentPop.length / 5); // высота бара
                    var BarCurPos = parseInt(aciveContent / 5) + 1;
                    var nt = (500 * BarCurPos) / BarHeight - 45;

					if (BarCurPos <= BarHeight)
                    	$(".scrollbar2 .scrollbar_bg2 .handler2").css("top", parseInt(nt));
					
				}
                if(Promo.length == 0 && ContentNew.length == 0 && ContentPop.length <= 2*MAX_LINE_CONTENTS)
                    $(".scrollbar2 .scrollbar_bg2 .handler2").hide();
                else
                    $(".scrollbar2 .scrollbar_bg2 .handler2").show();
			}
			else
            {
                alert("null content. cat:" + category + ",  + gen:" + genre + ", sort:" + sort);
                Visual.HidePreloader();
            }
		}
	});
}

// получить информацию на видео/сборник
getInfo.getVideoInfo = function(is_serial, id, no_season, isSearch, opt)
{
    if (opt != undefined && opt['go_to_player'] == true) 
        Visual.ShowPreloader(false);
    else 
        Visual.ShowPreloader(true);
	setInfo.clearPreview();
	setInfo.clearCompPreview();
	$.ajax({
		type: "GET",
		url: first_adr + "action=getcontentinfo",
		data: 
		{
			"is_serial": is_serial,
			"id": id,
			"no_season": no_season 
		},
		dataType: "json",
		success: function(res)
		{
			if (res != null && res.res != null)
			{
				
				if (is_serial == 0) // получили инфу о фильме
				{
                    VideoInfo = null;
					VideoInfo = {genres: res.res.genres,
								 thumbnails: res.res.thumbnails,
								 title: res.res.title,
								 country: res.res.country,
								 artists: res.res.artists, //ладно хоть актеры есть, а где режисер?
								 ivi_rating: res.res.ivi_rating, 
								 kp_rating: res.res.kp_rating,
								 imdb_rating: res.res.imdb_rating,
								 year: res.res.year,
								 description: res.res.descrtiption,
								 id: res.res.id,
								 categories: res.res.categories,
                                 budget: res.res.budget,
                                 gross_usa: res.res.gross_usa,
                                 gross_russia: res.res.gross_russia,
                                 gross_world: res.res.gross_world};
					setInfo.placePreview(isSearch);
                    getInfo.getRecension(id, 100, null, false, 0);
				}
				else // получили инфу о сборнике
				{
                    CompInfo.length = 0;
					for (var i = 0; i < res.res.length; i++)
					{
						episode = new Array();
						for (var j = 0; j < res.res[i].episode.length; j++)
						{
							if (res.res[i].episode[j] != null)
							{
								episode[j] = {genres: res.res[i].episode[j].genres,
											  thumbnails: res.res[i].episode[j].thumbnails,
											  title: res.res[i].episode[j].title,
											  country: res.res[i].episode[j].country,
											  compilation: res.res[i].episode[j].compilation,
											  ivi_rating: res.res[i].episode[j].ivi_rating,
											  kp_rating: res.res[i].episode[j].kp_rating,
											  imdb_rating: res.res[i].episode[j].imdb_rating,
											  year: res.res[i].episode[j].year,
											  description: res.res[i].episode[j].descrtiption,
											  id: res.res[i].episode[j].id,
											  categories: res.res[i].episode[j].categories};
							}
						}
						CompInfo[i] = {comp_info: res.res[i].comp_info,
									   season_no: res.res[i].season_no,
									   episode: episode};
					}
					setInfo.placeCompPreview();
                    getInfo.getRecension(id, 100, null, false, 1);
				}
				if (opt != undefined && opt['go_to_player'] == true)
				{
					if (opt['isSerial'] == 1)
					{
						current_siason_no = 0;
						current_episode = 0;
						getInfo.getVideoUrl(CompInfo[0].episode[0].id, opt);
					}
					else 
						getInfo.getVideoUrl(id, opt);
				}
				if (res.rev != null && res.rev.length > 0) // рецензии есть
				{
					$(".reviews").show();
				}
				else // рецензий нет
				{
					$(".reviews").hide();
				}
			}
			else
				alert("null info. is_serial:" + is_serial + ",  + id:" + id);
		}
	});
	//Visual.HidePreloader();
}

// получить ссылку на видео
getInfo.getVideoUrl = function(id, opt)
{
	$.ajax({
		type: "GET",
		url: first_adr + "action=getvideourl",
		data: 
		{
			"id": id
		},
		dataType: "json",
		success: function(res)
		{
			Visual.ShowPreloader(false);
			if (res != null && res.res != null)
			{
				VideoUrl = {url_hi: res.res.url_hi, 
							url_lo: res.res.url_lo, 
							midroll: res.res.midroll, 
							percent: res.res.percent, 
							id: res.res.id};
				getInfo.getAdvUrl(id, opt);
			}
			else
				alert("null url video. id:" + id);
		}
	});
}

// получить ссылку на рекламу
getInfo.getAdvUrl = function(id, opt)
{
    $.ajax({
        type: "GET",
        url: first_adr + "action=getadvurl",
        data:
        {
            "id": id
        },
        dataType: "json",
        success: function(res)
        {
            AdvUrl = {
                url_hi:    '',
                url_lo:    '',
                save_show: false,
                duration:  0,
                percent:   0,
                id:        0,
                type:      "postroll",
                played:    true
            };            
            if (res != null && res.res.url_hi != null)
            {
                AdvUrl = {
                    url_hi:    res.res.url_hi,
                          url_lo:    res.res.url_lo,
                          save_show: res.res.save_show,
                          duration:  res.res.duration,
                          percent:   res.res.percent_to_mark,
                          id:        res.res.id,
	                    type:      res.res.type,
	                    played:    false
                };                
            }
            else
                alert("null url adv. id_video:" + id);
			// должен сработать всегда
			setInfo.placeVideo(opt);
        }
    });
}

// сохранить просмотр рекламы
getInfo.saveShowAdv = function(id_video, id_adv)
{
	$.ajax({
		type: "GET",
		url: first_adr + "action=saveshowadv",
		data: 
		{
			"adv_id": id_adv, 
			"vid_id": id_video
		},
		dataType: "json",
		success: function(res)
		{
			if (parseInt(res.val) != 1)
				alert("adv saving failed. id_video:" + id_video + ", id_adv:" + id_adv);
			if (parseInt(res.val) == 1)
				alert("adv saving success. id_video:" + id_video + ", id_adv:" + id_adv);
		}
	});
}

// уведомить ДА о просмотре рекламы
getInfo.markAdvDA = function(id_video, id_adv)
{
	$.ajax({
		type: "GET",
		url: first_adr + "action=markadvda",
		data: 
		{
			"adv_id": id_adv, 
			"vid_id": id_video
		},
		dataType: "json",
		success: function(res)
		{
			if (parseInt(res.val) != 1)
				alert("mark DA adv failed. id_video:" + id_video + ", id_adv:" + id_adv);
			if (parseInt(res.val) == 1)
				alert("mark DA adv success. id_video:" + id_video + ", id_adv:" + id_adv);
		}
	});
}

// уведомить ДА о просмотре видео
getInfo.markVideoDA = function(id_video)
{
	$.ajax({
		type: "GET",
		url: first_adr + "action=markvideoda",
		data: 
		{
			"vid_id": id_video
		},
		dataType: "json",
		success: function(res)
		{
			if (parseInt(res.val) != 1)
				alert("mark DA video failed. id_video:" + id_video);
			if (parseInt(res.val) == 1)
				alert("mark DA video success. id_video:" + id_video);
		}
	});
}

// получить список рецензий на видео
getInfo.getRecension = function (id_video, limit, page, isSearch, isSerial)
{
    Recension.length = 0;
	$(".reviews").show(); // показать сраную кнопку
	isBlockRecBut = true;
	//Visual.ShowMiniPreloader();
	
    //if (isSerial != 1)
    //{
        $.ajax({
            type: "GET",
            url: first_adr + "action=getreview",
            data:
            {
                "id": id_video,
                "limit": limit,
                "page":page
            },
            dataType: "json",
            success: function(res)
            {
                if (res != null && res.res != null)
                {

                    for (var i = 0; i < res.res.length; i++)
                    {
                        Recension[i] = {username: res.res[i].username,
                                        added: res.res[i].added, // строка с датой
                                        canlike: res.res[i].canlike, // какой-то флажок
                                        text: res.res[i].text,
                                        canchange: res.res[i].canchange, // еще какой-то флажок
                                        likes: res.res[i].likes,
                                        user_rate: res.res[i].user_rate,
                                        id: res.res[i].id,
                                        avatar: res.res[i].avatar};
                    }
                    setInfo.placeRecension(isSearch, isSerial);
                }
                else
                    alert("null recension. id_video:" + id_video);
                Visual.ShowHideRecButton();
            }
        });
    //}
    //else
        //Visual.ShowHideRecButton();
}

// получить результаты поиска
getInfo.Search = function (query)
{
	Visual.ShowPreloader(true);
	
    Search.length = 0;
    $.ajax({
        type: "GET",
        url: first_adr + "action=search",
        data:
        {
            "query": query
        },
        dataType: "json",
        success: function(res)
        {
			Visual.ShowPreloader(true);
            if (res != null && res.res != null)
            {
                for (var i = 0; i < res.res.length; i++)
                {
					if (res.res[i].compilation > 0 /*res.res[i].seasons_count != null && res.res[i].seasons_count != undefined*/) // перед нами сборник
					{
	                    Search[i] = {id: res.res[i].id,
	                                 title: res.res[i].title,
	                                 categories: res.res[i].categories,
	                                 genres: res.res[i].genres,
	                                 description: res.res[i].descrtiption,
	                                 compilation: res.res[i].id,
	                                 country: res.res[i].country,
	                                 kp_rating: res.res[i].kp_rating,
	                                 ivi_rating: res.res[i].ivi_rating,
	                                 year: res.res[i].year,
                            thumbnails: res.res[i].thumbnails,
                            type: VINFO_SERIAL
                        };
					}
					else // перед нами обыкновенное кино
					{
	                    Search[i] = {id: res.res[i].id,
	                                 title: res.res[i].title,
	                                 categories: res.res[i].categories,
	                                 genres: res.res[i].genres,
	                                 description: res.res[i].descrtiption,
	                                 compilation: 0,
	                                 country: res.res[i].country,
	                                 kp_rating: res.res[i].kp_rating,
	                                 ivi_rating: res.res[i].ivi_rating,
	                                 year: res.res[i].year,
                            thumbnails: res.res[i].thumbnails,
                            type: VINFO_FILM
                        };
					}
                }
                setInfo.placeSearch();
            }
            else
            {
                setInfo.placeSearch();
                alert("null search. query:" + query);
            }
        }
    });
}

// авторизовацо
getInfo.autorisation = function (soc_type, login, pass)
{
    $.ajax({
        type: "GET",
        url: first_adr + "action=autorisation",
        data:
        {
            "mode": soc_type,
            "login": login,
            "pass": pass
        },
        dataType: "json",
        success: function(res)
        {
            if(parseInt(res.res.id) > 0)
            {
                id_user = parseInt(res.res.id);
                user_name = $("." + nameLoginInput).val();
                setInfo.placeAuto();
            }
            else
            {
                my_action_prev = NAME_AUTORISATION;
                my_action = NAME_REPORT;
                myEvent.gotoUrl(my_action)
                Visual.ShowReportWindow("Ошибка авторизации");
            }
        }
    });
}

// сохранить избранное пользователя
getInfo.SaveFavorite = function (soc_type, id_user, id_content, is_serial, season_no)
{
    $.ajax({
        type: "GET",
        url: first_adr + "action=savefav",
        data:
        {
            "soc_type": soc_type,
            "id_user": id_user,
            "id_content": id_content,
            "is_serial": is_serial,
            "season_no": season_no
        },
        dataType: "json",
        success: function(res)
        {
            if (parseInt(res.val) != 1)
                alert("favorite saving failed. id_user:" + soc_type + id_user + ", id_content:" + id_content);
            if (parseInt(res.val) == 1)
                alert("favorite saving success. id_user:" + soc_type + id_user + ", id_content:" + id_content);
        }
    });
}

// получить избранное юзера
getInfo.GetFavorite = function (soc_type, id_user)
{
    $.ajax({
        type: "GET",
        url: first_adr + "action=getfav",
        data:
        {
            "soc_type": soc_type,
            "id_user": id_user
        },
        dataType: "json",
        success: function(res)
        {
			Visual.ShowPreloader(true);
			var vid = new Array();
			for (var i = 0; i < res.res.vid.length; i++)
			{
				vid[i] = {genres:       res.res.vid[i].genres,
						  thumbnails:   res.res.vid[i].thumbnails,
						  title:        res.res.vid[i].title,
						  country:      res.res.vid[i].country,
						  artists:      res.res.vid[i].artists,
						  budget:       res.res.vid[i].budget,
						  gross_usa:    res.res.vid[i].gross_usa,
						  ivi_rating:   res.res.vid[i].ivi_rating,
						  kp_rating:    res.res.vid[i].kp_rating,
						  imdb_rating:  res.res.vid[i].imdb_rating,
						  gross_russia: res.res.vid[i].gross_russia,
						  gross_world:  res.res.vid[i].gross_world,
						  year:         res.res.vid[i].year,
						  description:  res.res.vid[i].descrtiption,
						  id:           res.res.vid[i].id,
						  categories:   res.res.vid[i].categories,
						  seasons_count: 0,
						  is_serial: 0};
			}
			var comp = new Array();
			for (var i = 0; i < res.res.comp.length; i++)
			{
                /*
				var season = new Array();
				for (var j = 0; j < res.res.comp[i].episode.length; j++)
				{
					episode = new Array();
					for (var k = 0; k < res.res.comp[i].episode[j].episode.length; k++)
					{
						if (res.res.comp[i].episode[j].episode[k] != null)
						{
							episode[k] = {genres:      res.res.comp[i].episode[j].episode[k].genres,
										  thumbnails:  res.res.comp[i].episode[j].episode[k].thumbnails,
										  title:       res.res.comp[i].episode[j].episode[k].title,
										  country:     res.res.comp[i].episode[j].episode[k].country,
										  compilation: res.res.comp[i].episode[j].episode[k].compilation,
										  ivi_rating:  res.res.comp[i].episode[j].episode[k].ivi_rating,
										  //kp_rating: res.res.comp[i].episode[j].kp_rating,
										  //imdb_rating: res.res.comp[i].episode[j].imdb_rating,
										  year:        res.res.comp[i].episode[j].episode[k].year,
										  description: res.res.comp[i].episode[j].episode[k].descrtiption,
										  id:          res.res.comp[i].episode[j].episode[k].id,
										  categories:  res.res.comp[i].episode[j].episode[k].categories};
						}
					}
					season[j] = {season_no: res.res.comp[i].episode[j].season_no,
						   		 episode: episode};
				}
                */
				comp[i] = {genres: res.res.comp[i].val.genres,
						   thumbnails: res.res.comp[i].val.thumbnails,
						   title: res.res.comp[i].val.title,
						   hru: res.res.comp[i].val.hru,
						   seasons: res.res.comp[i].val.seasons,
						   desciption: res.res.comp[i].val.description,
						   id: res.res.comp[i].val.id,
						   categories: res.res.comp[i].val.categories,
						   total_contents: res.res.comp[i].val.total_contents,
						   seasons_count: res.res.comp[i].val.seasons_count,
						   is_serial: 1/*,
						   season: season*/};
			}
			Favorite.vid = vid;
			Favorite.comp = comp;
            setInfo.placeFavorites();
        }
    });
}

// получить один логин юзера
getInfo.getLoginUser = function(soc_type, val)
{
    $.ajax({
        type: "GET",
        url: first_adr + "action=getloginname",
        data:
        {
            "soc_type": soc_type,
            "val": val
        },
        dataType: "json",
        success: function(res)
        {
			if (res != null && res.res != null && res.res != "null") // случился единственный пароль
			{
				setInfo.placeOneLogin(res.res);
			}
        }
    });
}

// получить набор слов по введенной маске кодов
getInfo.getT9words = function(keys, lang)
{
	T9.length = 0;
    $.ajax({
        type: "GET",
        url: first_adr + "action=tnine",
        data:
        {
            "keys": keys,
            "lang": lang
        },
        dataType: "json",
        success: function(res)
        {
			if (res != null && res != "null" && res.res != null && res.res != "null")
			{
				for (var i = 0; i < res.res.length; i++)
				{
					if (res.res[i] != "null" && 
						res.res[i] != null && 
						res.res[i] != undefined && 
						res.res[i] != "undefined")
						T9[i] = res.res[i];
				}
				setInfo.placeT9words();
			}
        }
    });
}
