﻿/**
* @file      ucc_2.js
* @brief     위젯의 동작 및 화면을 제어하는 자바스크립트
* @author   Seungho Park
* @date      04 JUL 2008 
*/

// ===================================
//  옵션 팝업 만들기 
// ===================================
/**
 * @brief			옵션 팝업 만들기 
 * @remarks		옵션 팝업 Div 태그를 생성한다
 * @param		menuArr			메뉴 text array
 * @param		callbackFunc	옵션팝업에서 엔터키를 눌렀을때 동작할 함수
 * @param		disableIdxArr	옵션메뉴에서 활성화, 비활성화를 처리하기 위한 array, 메뉴 갯수만큼 array를 new해서 넘겨야한다.
 * @return	 	void
*/
function createOptionPopup( menuArr, callbackFunc, disableIdxArr ) {
	TRACE("createOptionPopup()");
	var i, j;
	var bDisable = false;
	var popupMenu = menuArr;
	gOptionMenuNum = popupMenu.length; // 팝업 메뉴 갯수
	var nDisableNum = 0; // 비활성화 인덱스 array
    var totalLine = "<ul>";
	var tmpID;
	var tmpIndex;
	var tmpLine;
	if ( disableIdxArr ) {
		nDisableNum = disableIdxArr.length;
		gDisableIdxArr = disableIdxArr;
	}
   for ( i=0 ; i<gOptionMenuNum ; i++) {
		bDisable = false;
		
		if( disableIdxArr) {
			if ( disableIdxArr[i] == true) {
				bDisable = true;
			}	
		}	
		
        tmpID = optionPopupID + (i+1);
        tmpIndex = i+1;

        if(bDisable == false){
			tmpLine = "<li><a id="+tmpID+" class = 'optionEnable' href='javascript: void(0);' onkeydown='option_popup_inputKey(this," + callbackFunc + ")'; onfocus= popupBookmarkFocus(this); onblur=popupBookmarkBlur(this); name="+tmpIndex+">" + popupMenu[i] + "</a></li>";			
		} else {
			tmpLine = "<li><a id="+tmpID+" class = 'optionDisable' href='javascript: void(0);' onkeydown='option_popup_inputKey(this," + callbackFunc + ")'; onfocus= popupBookmarkFocus(this); onblur=popupBookmarkBlur(this); name="+tmpIndex+">" + popupMenu[i] + "</a></li>";
		}		
        totalLine += tmpLine;
    }
    totalLine += "</ul>";
    document.getElementById('optionMiddle').innerHTML = totalLine;
}
/**
 * @brief			팝업 보여주기 
 * @remarks		옵션 팝업 Div 보여주기
 * @param		void
 * @return	 	void
*/
function showOptionPopup() {
	document.getElementById("optionPopup").style.visibility = "visible" ;
	locateFocus = optionPopupID;
	
    if (locateFocus==optionPopupID) {
		if( gDisableIdxArr[0] ){
			lastOptionFocusID = "OptionPopup2";	
			document.getElementById(optionPopupID + 2).focus();
		}else{
			lastOptionFocusID = "OptionPopup1";	
			document.getElementById(optionPopupID + 1).focus();
		}
 	       
    }
	hideAllHelpLayer();
	showHelpListPopup();
}

/**
 * @brief			팝업 숨기기
 * @remarks		옵션 팝업 Div 숨기기
 * @param		void
 * @return	 	void
*/
function hideOptionPopup() {
	document.getElementById("optionPopup").style.visibility = "hidden" ;
}

/**
 * @brief			팝업창 키 입력 함수
 * @remarks		옵션 팝업창 키처리 함수. 상, 하, 복귀, 엔터키 동작 구현되어있음
 * @param		obj				focused tag object
 * @param		callbackFn	엔터키를 눌렀을 경우 처리할 함수 
 * @return	 	void
*/
function option_popup_inputKey(obj, callbackFn) {
	try {
		TRACE("option_popup_inputKey():"+ gDisableIdxArr);
//	    var ie = (document.all) ? 1:0
//	    if (ie) { var EKC = event.keyCode;}
	    var EKC = event.keyCode;
	    var Idx = obj.name; //해당 Index 가져오기..
	    var tmpPopupID;
		var tmpDisableIdxArr = new Array();
		var nDisableNum = 0;
		var i;
	   	if ( gDisableIdxArr ) {
			nDisableNum = gDisableIdxArr.length;
		}
		TRACE("curpopup :::: "+curPopup);
		TRACE( "Input Key = " + EKC);
		CommonLib.keyHandler(EKC,popupCallback);	
		switch (EKC) {
//	        case (38) : 					// Up 화살표....
	        case (tvKey.KEY_UP) : 	// Up 화살표.... 
	        case (tvKey.KEY_WHEELUP) :	// remocon wheel left
	        case (tvKey.KEY_PANEL_CH_UP) :		// 패털키 UP
	        	if(bMaple && EKC==38) return false;
	            if(Idx==1){
					Idx = gOptionMenuNum;
					
					if( gDisableIdxArr[Idx -1 ] ){
						Idx--;
					}
					     
	                tmpPopupID = optionPopupID + Idx;
	                document.getElementById(tmpPopupID).focus();
	            }else{
	                Idx--;
					if( gDisableIdxArr[Idx -1 ] ){
						Idx--;
					}
					if(Idx < 1) Idx = gOptionMenuNum;
						
	                tmpPopupID = optionPopupID + Idx;		
					lastOptionFocusID = tmpPopupID;								
	                document.getElementById(tmpPopupID).focus();
	            }           
	        	break;
	        
//	        case (40) : 						//down 화살표...
	        case (tvKey.KEY_DOWN) : //down 화살표... 
	        case (tvKey.KEY_WHEELDOWN): 	// remocon wheel right
	        case (tvKey.KEY_PANEL_CH_DOWN):		// 패널키 Down 
	        	if(bMaple && EKC==40) return false;            
			
				Idx++;
				if(Idx > gOptionMenuNum) Idx = 1;
									
				if( gDisableIdxArr[Idx-1])
					Idx++;
				if(Idx > gOptionMenuNum) Idx = 1;
			
				tmpPopupID = optionPopupID + Idx;
				lastOptionFocusID = tmpPopupID;				
	            document.getElementById(tmpPopupID).focus();
	
	        	break;
	        
	//        case (27) : 							//ESC
	        case (tvKey.KEY_RETURN) : 	// ESC
	        case (tvKey.KEY_PANEL_MENU): 		// 패널 키 ESC
	        case (tvKey.KEY_EXIT): 		//Exit Key       
	//        	if(bMaple ) return false; 
		        blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다        
				hideOptionPopup();
				TRACE("lastFocusID "+lastFocusID)
				if(curPopup == POPUP_HISTORY_DEL && isSearch() && lastFocusID.indexOf(historyID)==0) {
					locateFocus = searchID;			 		
					document.getElementById(lastFocusID).focus();        
				} else {
					locateFocus = contentsID;					
					document.getElementById(lastContentsID).focus();        	
				}
				
	       		break;
	        
//	        case (13) : 							//Enter
	        case (tvKey.KEY_ENTER) : 	//Enter       
	        case (tvKey.KEY_PANEL_ENTER) : 		// 패널 키 Enter
	        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
	        	if(bMaple && EKC==13) return false;     
				callbackFn(EKC, obj);
	        	break;
	
				break;
	        default  : 
				
	        	return false;
	        	break;
	    }	
	} catch (e) {
		TRACE("error :: "+e);
	}
}
/**
 * @brief		팝업 위치변경
 * @remarks		옵션 팝업 위치변경하기
 * @param		void
 * @return	 	void
*/
function changePosOptionPopup() {
	var objOptionPopup = document.getElementById("optionPopup");
	
	if(locateFocus == historyID) {
		objOptionPopup.style.left="720px";		
		objOptionPopup.style.top="230px";	
	} else {
		objOptionPopup.style.left="747px";		
		objOptionPopup.style.top="90px";	
	}
}

// ===================================
//  기간 선택 팝업 만들기 
// ===================================
/**
 * @brief			기간 선택 팝업
 * @remarks		팝업 Div 태그 만드는 작업 
 * @param		void
 * @return	 	void
*/
function createTimePopup() {
	var popupMenu = new Array(SID_TODAY, SID_WEEKLY_KR_WEEK, SID_MONTHLY_KR_MONTH, SID_ALL); 
	var menuNum = popupMenu.length; // 팝업 메뉴 갯수
	var tmpID, tmpIndex;
	var tmpLine = "";
	for ( i=0 ; i<menuNum ; i++) {
        tmpID = timePopupID + i;
        tmpIndex = i;
        tmpLine += "<div><a id="+tmpID+" href=javascript: onkeydown=time_popup_inputKey(this); onfocus= popupTimeFocus(this); onblur=popupTimeBlur(this); name="+tmpIndex+">" + popupMenu[i] + "</a></div>";
    }
//	alert(tmpLine);
    document.getElementById('timePopupText').innerHTML = tmpLine;
    
}
/**
 * @brief			팝업 보여주기 
 * @remarks		기간선택 팝업 Div 보여주기
 * @param		void
 * @return	 	void
*/
function showTimePopup() {
	//document.getElementById("timePoup_background").style.visibility = "visible" ;
	document.getElementById("timePopup").style.visibility = "visible" ;
	if(lastTimeFocusID != null)	lastTimeFocusID.parentNode.style.backgroundImage = "url(none)";
	locateFocus = timePopupID;
    if (locateFocus==timePopupID) {
		var focusID =  timePopupID + getFocusTimeIndex();
		var focusObj = document.getElementById(focusID);
		lastTimeFocusID = focusObj;
        focusObj.focus();
    }	
	hideAllHelpLayer();
//	bTimePopup = true;
	//showHelpListPopup();
}

/**
 * @brief			팝업 숨기기
 * @remarks		기간선택 팝업 Div 숨기기
 * @param		void
 * @return	 	void
*/
function hideTimePopup() {
	document.getElementById("timePopup").style.visibility = "hidden" ;
	//document.getElementById("timePoup_background").style.visibility = "hidden" ;
//	bTimePopup = false;
}

/**
 * @brief			팝업 항목에 포커스가 있을 때 화면 처리
 * @remarks		팝업 바탕에 이미지를 배경으로 깔아서 포커스 효과를 나타낸다.
* @param		obj		HTML Object
* @return		void
*/
function popupTimeFocus(obj){
//	obj.style.color = "#FFFFFF";
	//lastTimeFocusID.parentNode.style.backgroundImage = "url(img/ucc_selected.png)";
    obj.parentNode.style.border = "none";
    obj.parentNode.style.backgroundImage = "url(img/button_select_11.png)";	
}
/**
 * @brief			팝업 항목에서 포커스를 벗어날 때 화면 처리
 * @remarks		팝업 바탕에 이미지를 없애고 투명하게 만든다.
* @param		obj		HTML Object
* @return		void
*/
function popupTimeBlur(obj){
//	obj.style.color = "#000000";
    obj.parentNode.style.border = "none";
    obj.parentNode.style.backgroundColor = "transparent";
	obj.parentNode.style.backgroundImage = "url(none)"; 	
}

/**
 * @brief			팝업창 키 입력 함수
 * @remarks		기간선택 팝업창 키처리 함수 좌, 우,  복귀, 엔터키 처리 
 * @param		obj		focused tag object
 * @return	 	void
*/
function time_popup_inputKey(obj) {
//    var ie = (document.all) ? 1:0
//    if (ie) { var EKC = event.keyCode;}
	var EKC = event.keyCode;
	var menuNum = 4;
    var Idx = obj.name; //해당 Index 가져오기..
	TRACE("key num : " + EKC);
	CommonLib.keyHandler(EKC,popupCallback);	
    var tmpPopupID;
    switch (EKC) {
//        case (37) : 						// Left Key
        case (tvKey.KEY_LEFT) : 	// Left Key 
        case (tvKey.KEY_WHEELUP): 		// remocon wheel left
        case (tvKey.KEY_PANEL_CH_UP) :		// Panel Left
        	if(bMaple && EKC==38) return false;
            if(Idx==0){
				Idx = menuNum-1;     
                tmpPopupID = timePopupID + Idx;
                document.getElementById(tmpPopupID).focus();
            }else{
                Idx--;
                tmpPopupID = timePopupID + Idx;
                document.getElementById(tmpPopupID).focus();
            }         
        	break;
        
//        case (39) : 						// Right Key
        case (tvKey.KEY_RIGHT) : // Right Key 
        case (tvKey.KEY_WHEELDOWN): 	// remocon wheel right
        case (tvKey.KEY_PANEL_CH_DOWN):		// Panel Right 
        	if(bMaple && EKC==40) return false;
            if(Idx==menuNum-1){
				Idx = 0;     
                tmpPopupID = timePopupID + Idx;
                document.getElementById(tmpPopupID).focus();
            }else{       
                Idx++;      
                tmpPopupID = timePopupID + Idx;
                document.getElementById(tmpPopupID).focus();
            }
        	break;
        
//        case (27) : 							// ESC
        case (tvKey.KEY_RETURN) : 	// ESC
        case (tvKey.KEY_PANEL_MENU): 		// 패널 키 ESC
        case (tvKey.KEY_EXIT):		 	//Exit Key       
//        	if(bMaple) return false; 
	        blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다        
			hideTimePopup();
			bOnCategoryList = true;
			document.getElementById(lastFocusID).focus();  
       		break;
        
//        case (13) : 							// Enter
        case (tvKey.KEY_ENTER) : 	// Enter       
        case (tvKey.KEY_PANEL_ENTER) : 		// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
        	var sendMsg;
        	if(bMaple && EKC==13) return false;     
			if ( Idx == 0 ) { // 오늘
				contentsListXmlParam[lastCategoryIndex] = PARAM_TIME_DAY;
			} else if ( Idx == 1 ) {	// 이번 주 
				contentsListXmlParam[lastCategoryIndex] = PARAM_TIME_WEEK;
			} else if ( Idx == 2 ) {	// 이번 달
				contentsListXmlParam[lastCategoryIndex] = PARAM_TIME_MONTH;
			} else { // 전체 기간
				contentsListXmlParam[lastCategoryIndex] = PARAM_TIME_ALLTIME;
			}
			
			hideTimePopup();
			initCheckList();
			reloadCategorylist();
        	break;

			break;
        default  : 
			
        	return false;
        	break;
    }	
}

// ===================================
//  카테고리 기간 선택
// ===================================
/**
 * @brief			Feed Url 을 생성
 * @remarks		기본적인 Feed url 에 파라미터를 지원하는 리스트의 경우 (시간등) 파라미터를 뒤에 붙여서 최종 feed url을 생성한다.
 * @param		nIndex		Contents index ( 0 base )
 * @return	 	feed url
*/
function makeFeedUrl ( nIndex ) {
	var strFeedUrl;
//	if ( !isBookmark() && !isSearch() && !isHistory() ) {
	if ( isSupportTimeparam(nIndex) ) {
		strFeedUrl = contentsListXmlURL[nIndex] + contentsListXmlParam[nIndex];
	} else {
		strFeedUrl = contentsListXmlURL[nIndex];
	}
	
	return strFeedUrl;
}

/**
 * @brief			시간 선택 파라미터 가능여부 확인
 * @remarks		Feed url 이 시간 선택이 가능한 url 인지 확인
 * @param		nIndex		Contents index ( 0 base )
 * @return	 	bReturn	true 가능, false 불가
*/
function isSupportTimeparam( nIndex ) {
	var bReturn = true;
	
	if ( isBookmark() || isTvBookmark()||isSearch() || isHistory() || contentsListXmlURL[nIndex].indexOf("recently_featured") > -1) {
		bReturn = false;	
	}
	
	if( bDemo ) {
		bReturn = false;
	}
	
	return bReturn;
}

/**
 * @brief			현재 선택한 카테고리의 날짜 index를 리턴
 * @remarks		현재 선택한 카테고리의 날짜 index를 리턴
 * @param		void
 * @return	 	nIndex		0 오늘, 1 이번주, 2 이번달, 3 전체기간
*/
function getFocusTimeIndex() {
	var nIndex = 0;
	
	switch( contentsListXmlParam[lastCategoryIndex] )	{
		
		case PARAM_TIME_DAY :
			nIndex = 0;
			break;
		case PARAM_TIME_WEEK :
			nIndex = 1;
			break;
		case PARAM_TIME_MONTH :
			nIndex = 2;
			break;
		case PARAM_TIME_ALLTIME :
			nIndex = 3;
			break;
		default :
			nIndex = 0;
			break;
	}
	return nIndex;
}

/**
 * @brief			현재 선택한 카테고리의 날짜 항목을 리턴
 * @remarks		현재 선택한 카테고리의 날짜 항목을 리턴
 * @param		void
 * @return	 	strName	기간 파라미터 이름
*/
function getFocusTimeName() {
	var strName = 0;
	
	switch( contentsListXmlParam[lastCategoryIndex] )	{
		
		case PARAM_TIME_DAY :
			strName = SID_TODAY;
			break;
		case PARAM_TIME_WEEK :
			strName = SID_WEEKLY_KR_WEEK;
			break;
		case PARAM_TIME_MONTH :
			strName = SID_MONTHLY_KR_MONTH;
			break;
		case PARAM_TIME_ALLTIME :
			strName = SID_ALL;
			break;
		default :
			strName = "";
			break;
	}
	return strName;
}

/**
 * @brief			기간 표시 보여줌
 * @remarks		기간 표시 보여줌
 * @param		void
 * @return	 	void
*/
function showTimeParam() {
	
	var strTimeParam = "";
	
	if ( isSupportTimeparam(lastCategoryIndex) ) {
		strTimeParam = getFocusTimeName();
		document.getElementById("timeParam").innerHTML = adaptString(strTimeParam);
	} else {
		document.getElementById("timeParam").innerHTML = "";
	}
}

/**
 * @brief			기간 표시 숨김
 * @remarks		기간 표시 숨김
 * @param		void
 * @return	 	void
*/
function hideTimeParam() {
	document.getElementById("timeParam").innerHTML = "";
	document.getElementById("timeParam").style.border = "none";
    document.getElementById("timeParam").style.backgroundColor = "transparent";
	document.getElementById("timeParam").style.backgroundImage = "url(none)"; 
}

/**
 * @brief			category 다시 읽기
 * @remarks		category 다시 읽기
 * @param		void
 * @return	 	void
*/
function reloadCategorylist() {
	TRACE("reloadCategorylist()");
	var callUrl = "";
	var Idx, tmpCategoryID;
	bOnCategoryList = true;
	Idx = lastCategoryIndex + 1;     
	createLeftSideHTML(Idx-1);
	
	lastCategoryID = categoryID + Idx; 
	TRACE("lastCategoryID = " + lastCategoryID);
    document.getElementById(lastCategoryID).focus();
	
	//엔터키동작 
    locateFocus = categoryID;
	lastFocusID = lastCategoryID;
    contentsCategoryID = categoryList[Idx-1];
	bSearchSend = false;
	TRACE ("bSearchSend = " + bSearchSend);
	
	if ( bLoginMode && isBookmark() ) {
		callUrl = getBookmarkUrl();
	} else {
		callUrl = makeFeedUrl(Idx-1); //contentsListXmlURL[Idx-1];
	}
//	TRACE ( "reloadCategorylist callUrl = " + callUrl );
    loadXMLDoc(callUrl, contentsID);
}

// ===================================
// 방문기록 
// ===================================
/**
 * @brief			방문기록 파일 존재여부 확인
 * @remarks		방문기록 파일의 존재여부를 확인하여, 존재하지 않으면 빈 history.xml 파일을 생성한다.
 * @param		void
 * @return	 	void
*/
function checkHistoryFile() {
    TRACE("checkHistoryFile");

	if ( !bMaple )
		return;
	var fs = new FileSystem();
    if (fs.isValidCommonPath(favoriteDir+"/"+historyFile) != 0) { // 파일이 존재함
		return;
    } else { // 파일이 존재하지 않음
		resetHistoryFile();
	}
}

/**
 * @brief		    방문기록 항목 초기화
 * @remarks		history.xml을 초기화한다.
 * @param		void
 * @return 		void
*/
function resetHistoryFile() {
    TRACE("resetHistoryFile");
    //관심종목 파일을 삭제한다.
	var fs = new FileSystem();
	offWatchDog();
	if ( !favoriteDir || favoriteDir.length == 0 ) {
		TRACE("Can't find Favorite Dir!", TRACE_LEVEL.ERROR);
		return;
	}
    if (fs.isValidCommonPath(favoriteDir+"/"+historyFile) != 0) {
        fs.deleteCommonFile(favoriteDir+"/"+historyFile);
    }
	fs.createCommonDir(favoriteDir);
	var fp = fs.openCommonFile(favoriteDir+"/"+historyFile, "w");
	
	if(fp) {		// returns true-false
    	fp.writeAll(initHistoryXML);
		fs.closeFile(fp);					// closes file
		TRACE("Setting History File Write Success!!!");
	} else {
		TRACE("Setting History File Write Fail!!!", TRACE_LEVEL.ERROR);
    }	
	onWatchDog();
}
/**
 * @brief		    방문기록 파일 읽기
 * @remarks		history.xml을 읽어서 내용을 string으로 돌려준다.
 * @param		void
 * @return 		strHistory		방문기록 xml text
*/
function readHistoryFile() {
    TRACE("readHistoryFile");
	var strHistory = "";
    //file system 생성
	var fs = new FileSystem();
    offWatchDog();
    //favoriteCode file이 있는지 체크
    if (fs.isValidCommonPath(favoriteDir+"/"+historyFile) == 0) {
        TRACE("History File is not Found!!!", TRACE_LEVEL.ERROR);
		onWatchDog();
        return false;
    } else {
    	var fp = fs.openCommonFile(favoriteDir+"/"+historyFile, "r");
        if(fp) {		// returns true-false
        	strHistory = fp.readAll();
            fs.closeFile(fp);					// closes file
        }
    }
	onWatchDog();
	return strHistory;
}

/**
 * @brief			history 추가
 * @remarks		XML 타입의 history.xml을 읽어와서 현재 보는 contents의 데이터를 추가한다.
 * @param		void
 * @return	 	void
*/
function addHistory() {
	onAddHistory();
}

/**
 * @brief			History에 대한 XML 추가
 * @remarks		history.xml을 읽어와 dom으로 변환한 뒤 첫번째 item 을 생성, 현재 선택한 동영상의 XML 데이터를 추가한다.
 * @param 		void
 * @return 		void
*/
function onAddHistory() {
	// YouTube RSS
	var strXHRObject = "xmlHttpHistory";
//	if(checkReadyState(xmlHttpHistory, strXHRObject)) {
		TRACE("onAddHistory()");
			
			if ( bMaple ) {
				var doc;
				var parser;
				var strHistory = "";
	
				strHistory = readHistoryFile();
				if ( historyParser == null )
					historyParser = new DOMParser();
				doc = historyParser.parseFromString(strHistory,"text/xml");
			}

			var response = doc.documentElement;
			if ( !response ) {
//				stopLoadingonList();
//				curPopup = POPUP_NOTICE;			
//				openPopupWithTimer (SID_ERRMSG_XML, popupCallback, 5);				
				resetHistoryFile();
				return;
			}			
			var channelNode 	= response.getElementsByTagName("channel");
			var newItemNode = doc.createElement("item");
			var newTitle = doc.createElement("title");
			var newTitleText = doc.createCDATASection(contentsList[detailIndex]);
			var newDesc = doc.createElement("description");
			var newDescText = doc.createCDATASection(description[detailIndex]);
			var newDate = doc.createElement("pubDate");
			var newDateText = doc.createTextNode(contentsTime[detailIndex]);
			var newDateUpdate = doc.createElement("atom:updated");
			var newDateUpdateText = doc.createTextNode(contentsTimeUpdate[detailIndex]);
			var newGuid = doc.createElement("guid");
			var newGuidText = doc.createTextNode(videoGuid[detailIndex]);
			var newURL = doc.createElement("media:player");
			var newURL264 = doc.createElement("media:content");
			var newImg = doc.createElement("media:thumbnail");
			var newKeywords = doc.createElement("media:keywords");
			var newKeywordsText = doc.createCDATASection( keyWords[detailIndex]);
			var newStatistics = doc.createElement("yt:statistics");
			var newRating = doc.createElement("gd:rating");
//			alert("channelNode length = " + channelNode.length);
	
			bookmarkRoot = response;
			var itemList = response.getElementsByTagName("item");
			TRACE("itemList before add = " + itemList.length);
	
			var sendMsg;
			if (channelNode.length) {
				
				// 타이틀
				newTitle.appendChild(newTitleText);
				newItemNode.appendChild(newTitle);
	//			alert(newTitle.firstChild.data);
				// 상세정보
				newDesc.appendChild(newDescText);
				newItemNode.appendChild(newDesc);
	//			alert(newDesc.firstChild.data);
				// Video ID 정보
				newGuid.appendChild(newGuidText);
				newItemNode.appendChild(newGuid);
				// 날짜정보 for 영문 
				newDate.appendChild(newDateText);
				newItemNode.appendChild(newDate);
				// 날짜정보 for 한글 
				newDateUpdate.appendChild(newDateUpdateText);
				newItemNode.appendChild(newDateUpdate);
	//			alert(newDate.firstChild.data);
				// 동영상 URL
				newURL.setAttribute("url", playURL[detailIndex]);
				newItemNode.appendChild(newURL);		
	//			alert(newURL.getAttribute('url'));
				// h.264 동영상 URL
				if ( playURL264[detailIndex] && playURL264[detailIndex].length ) {
					newURL264.setAttribute("url", playURL264[detailIndex]);
					newURL264.setAttribute("type", playerType[detailIndex]);
					newURL264.setAttribute("duration", duration[detailIndex]);					
					newItemNode.appendChild(newURL264);		
//					TRACE(newURL264.getAttribute('url'));
				}
				// 썸네일 URL
				newImg.setAttribute("url", contentsImg[detailIndex]);
				newItemNode.appendChild(newImg);		
	//			alert(newImg.getAttribute('url'));
				// 키워드 
				newKeywords.appendChild(newKeywordsText);
				newItemNode.appendChild(newKeywords);
				// 조회수  	
				newStatistics.setAttribute("viewCount", viewcount[detailIndex]);
				newItemNode.appendChild(newStatistics);	
				// 평점
				newRating.setAttribute("average", average[detailIndex]);
				newItemNode.appendChild(newRating);	
	
				var bWritable = true;
				if (itemList.length)
					bWritable = checkExistHistory(itemList, playURL[detailIndex]);
				TRACE("bWritable? " + bWritable);
				if ( !bWritable ) {
				}					
				itemList = response.getElementsByTagName("item");
				if (itemList.length) {
						itemList[0].parentNode.insertBefore(newItemNode,itemList[0]);
				} else {
					channelNode[0].appendChild(newItemNode);
				}
			}
		
			response = doc.documentElement;
			if ( !response ) {
				stopLoadingonList();
				curPopup = POPUP_NOTICE;			
				openPopupWithTimer (SID_ERRMSG_XML, popupCallback, 5);
				return;
			}			
			itemList = response.getElementsByTagName("item");
			TRACE("itemList after add= " + itemList.length);
			
			historyXML = "<?xml version='1.0' encoding='utf-8'?>";
//			historyXML = "<?xml version='1.0' encoding='euc-kr'?>";
			makeHistoryXMLText(response);
//			TRACE("historyXML : " + historyXML);
			if (bMaple)
				writeHistoryFile();
}

/**
 * @brief			연관검색 History에 대한 XML 추가
 * @remarks		history.xml을 읽어와 dom으로 변환한 뒤 첫번째 item 을 생성, 연관검색 동영상의 XML 데이터를 추가한다.
 * @param 		void
 * @return 		void
*/
function RelatedAddHistory(nIndex) {
	// YouTube RSS
	var strXHRObject = "xmlHttpHistory";
//	if(checkReadyState(xmlHttpHistory, strXHRObject)) {
		TRACE("RelatedAddHistory()");
			
			if ( bMaple ) {
				var doc;
				var parser;
				var strHistory = "";
	
				strHistory = readHistoryFile();
				if ( historyParser == null )
					historyParser = new DOMParser();
				doc = historyParser.parseFromString(strHistory,"text/xml");
			}

			var response = doc.documentElement;
			if ( !response ) {
				stopLoadingonList();
				curPopup = POPUP_NOTICE;			
				openPopupWithTimer (SID_ERRMSG_XML, popupCallback, 5);
				return;
			}			
			var channelNode 	= response.getElementsByTagName("channel");
			var newItemNode = doc.createElement("item");
			var newTitle = doc.createElement("title");
			var newTitleText = doc.createCDATASection(relContentsList[nIndex]);
			var newDesc = doc.createElement("description");
			var newDescText = doc.createCDATASection(relDescription[nIndex]);
			var newDate = doc.createElement("pubDate");
			var newDateText = doc.createTextNode(relContentsTime[nIndex]);
			var newDateUpdate = doc.createElement("atom:updated");
			var newDateUpdateText = doc.createTextNode(relContentsTimeUpdate[nIndex]);
			var newGuid = doc.createElement("guid");
			var newGuidText = doc.createTextNode(relVideoGuid[nIndex]);
			var newURL = doc.createElement("media:player");
			var newURL264 = doc.createElement("media:content");
			var newImg = doc.createElement("media:thumbnail");
			var newKeywords = doc.createElement("media:keywords");
			var newKeywordsText = doc.createCDATASection( relKeyWords[nIndex]);
			var newStatistics = doc.createElement("yt:statistics");
			var newRating = doc.createElement("gd:rating");
//			alert("channelNode length = " + channelNode.length);
	
			bookmarkRoot = response;
			var itemList = response.getElementsByTagName("item");
			TRACE("itemList before add = " + itemList.length);
	
			var sendMsg;
			if (channelNode.length) {
				// 타이틀
				newTitle.appendChild(newTitleText);
				newItemNode.appendChild(newTitle);
				//alert(newTitle.firstChild.data);
				// 상세정보
				newDesc.appendChild(newDescText);
				newItemNode.appendChild(newDesc);
				//alert(newDesc.firstChild.data);
				// Video ID 정보
				newGuid.appendChild(newGuidText);
				newItemNode.appendChild(newGuid);
				// 날짜정보 for 영문 
				newDate.appendChild(newDateText);
				newItemNode.appendChild(newDate);
				// 날짜정보 for 한글 
				newDateUpdate.appendChild(newDateUpdateText);
				newItemNode.appendChild(newDateUpdate);
				//alert(newDate.firstChild.data);
				// 동영상 URL
				newURL.setAttribute("url", relPlayURL[nIndex]);
				newItemNode.appendChild(newURL);		
				//alert(newURL.getAttribute('url'));
				// h.264 동영상 URL
				if ( relPlayURL264[nIndex] && relPlayURL264[nIndex].length ) {
					newURL264.setAttribute("url", relPlayURL264[nIndex]);
					newURL264.setAttribute("type", relPlayerType[nIndex]);
					newURL264.setAttribute("duration", relDuration[nIndex]);					
					newItemNode.appendChild(newURL264);		
					//TRACE(newURL264.getAttribute('url'));
				}
				// 썸네일 URL
				newImg.setAttribute("url", relContentsImg[nIndex]);
				newItemNode.appendChild(newImg);		
				//alert(newImg.getAttribute('url'));
				// 키워드 
				newKeywords.appendChild(newKeywordsText);
				newItemNode.appendChild(newKeywords);
				// 조회수  	
				newStatistics.setAttribute("viewCount", relViewcount[nIndex]);
				newItemNode.appendChild(newStatistics);	
				// 평점
				newRating.setAttribute("average", relAverage[nIndex]);
				newItemNode.appendChild(newRating);	
	
				var bWritable = true;
				if (itemList.length){
					bWritable = checkExistHistory(itemList, relPlayURL[nIndex]);
				}					
				TRACE("bWritable? " + bWritable);
				if ( !bWritable ) {
				}
					
				itemList = response.getElementsByTagName("item");
				if (itemList.length) {
						itemList[0].parentNode.insertBefore(newItemNode,itemList[0]);
				} else {
					channelNode[0].appendChild(newItemNode);
				}
			}
		
			response = doc.documentElement;
			if ( !response ) {
				stopLoadingonList();
				curPopup = POPUP_NOTICE;			
				openPopupWithTimer (SID_ERRMSG_XML, popupCallback, 5);
				return;
			}			
			itemList = response.getElementsByTagName("item");
			TRACE("itemList after add= " + itemList.length);
			
			historyXML = "<?xml version='1.0' encoding='utf-8'?>";
//			historyXML = "<?xml version='1.0' encoding='euc-kr'?>";
			makeHistoryXMLText(response);
//			TRACE("historyXML : " + historyXML);
			if (bMaple)
				writeHistoryFile();
}

/**
 * @brief		방문기록 중복체크 
 * @remarks	현재 등록되어 있는 방문기록과 대조하여 중복되는 내용이면 기존것을 삭제
 * 검사 대상은 동영상 URL
 * 방문기록 저장 가능 최대 갯수를 넘어가면 마지막 항목을 삭제
 * 
 * @param 	itemNode		방문기록 item 항목 노드 
 * @param 	movieURL		동영상 url
 * @return	boolean		방문기록 노드가 꽉찼으면 false, otherwise true
 */
function checkExistHistory(itemNode, movieURL) {
//	alert("checkExistHistory()");
	if (itemNode) {
		var bookmarkURL;
		for( var i=0; i<itemNode.length; i++) {
			// 동영상 URL
			var tmpPlayUrl = itemNode[i].getElementsByTagName("media:player");

            if (tmpPlayUrl.length) {
        		bookmarkURL = tmpPlayUrl[0].getAttribute('url');
				// 이미 bookmark에 존재 하면 이전것은 삭제
//				TRACE("bookmarkURL ::: " + bookmarkURL);
//				TRACE("movieURL ::: " + movieURL);
				if ( bookmarkURL == movieURL ) { 
					itemNode[0].parentNode.removeChild(itemNode[i]);
					TRACE("duplicated node deleted!!");
					return true;
				}
            }
		}
		// 북마크 저장 최대 갯수를 넘어가면 마지막 항목을 삭제
		if (itemNode.length >= UCC_MAX_BOOKMARK) {
			itemNode[0].parentNode.removeChild( itemNode[UCC_MAX_BOOKMARK - 1] );
			TRACE("last node deleted!");
			return false;
		}
	}
	return true;
}

/**
 * @brief			XML Dom to Text 
 * @remarks		파라미터로 XML node를 받아 자신과 그 하위의 element, attribute, cdata, text 노드를 텍스트로 변환한다.
 * @param		node		top XML node to convert
 * @return	 	void
*/
function makeHistoryXMLText(node) {
	var nodeName;
	var nodeType;
	if (node) {
		do {
			nodeType = node.nodeType;
			nodeName = node.nodeName;
//			alert(nodeType);
//			alert(nodeName);
			if (nodeType == 1) {//element node
				historyXML += "<" + nodeName;
				for (i=0; i<node.attributes.length; i++) {
//					alert(node.attributes[i].name);
					historyXML += " " + node.attributes[i].name + "=";
					historyXML += "\"" + node.attributes[i].value + "\"";
				}
				historyXML += ">";
			}
			else if (nodeType == 3) //text node
				historyXML += node.nodeValue;
			else if (nodeType == 4) {//CDATA node
				historyXML += "<![CDATA[";
				historyXML += node.data + "]]>";
			}
			if (node.hasChildNodes()) {
				makeHistoryXMLText(node.firstChild);
			}
			if (nodeType ==1) //element node
				historyXML += "</" + nodeName + ">";
			node = node.nextSibling;
		} while(node)
	}
}

/**
 * @brief			history 저장 
 * @remarks		파일에 xml 타입으로 저장
 * @param		void
 * @return	 	void
*/
function writeHistoryFile() {
    TRACE("writeHistoryFile()");
	var fs = new FileSystem();

	offWatchDog();
    if (fs.isValidCommonPath(favoriteDir) == 0) {
        TRACE("Common Directory is not Found!!!", TRACE_LEVEL.ERROR)
        fs.createCommonDir(favoriteDir);
    }
	
	var fp = fs.openCommonFile(favoriteDir+"/"+historyFile, "w");
	
	if(fp) {		// returns true-false
    	var strHistoryXML = fp.writeAll(historyXML);
//		TRACE(historyXML);
		TRACE(strHistoryXML);
		fs.closeFile(fp);					// closes file
		TRACE("History File Write Success!!!");
	} else {
		TRACE("History File Write Fail!!!", TRACE_LEVEL.ERROR);
    }	
	onWatchDog();
}
/**
 * @brief			history 삭제 
 * @remarks		모두 지우기, 선택한 항목 지우기, 체크된 항목들 지우기
 * @param		void
 * @return	 	void
*/
function deleteHistory() {
	TRACE("deleteHistory");	
	if ( bMaple ) {
		var doc;
		var parser;
		var strHistory = "";

		strHistory = readHistoryFile();

		if ( historyParser == null )
			historyParser = new DOMParser();
		doc=historyParser.parseFromString(strHistory,"text/xml");
		TRACE("parseFromString doc =" +doc);
	}
	
	var response = doc.documentElement;
	if ( !response ) {
		stopLoadingonList();
		curPopup = POPUP_NOTICE;			
		openPopupWithTimer (SID_ERRMSG_XML, popupCallback, 5);
		return;
	}		
	
	var channelNode 	= response.getElementsByTagName("channel");
	TRACE("channelNode = " + channelNode.length);
	var itemList = response.getElementsByTagName("item");
	TRACE("itemList = " + itemList.length);
	

	if (channelNode.length) {
		if ( bDeleteAll ) { // 모두 지우기
			deleteAllHistory();
			return;
			TRACE("###### shouldn't call this LINE!!!! ######")
		} else if (checkListCnt != 0 ){
			var i;
			for(i = checkListCnt; i >= 0; i--){
				if ( itemList[checkPlayList[i]-1] ) {
					itemList[0].parentNode.removeChild(itemList[checkPlayList[i]-1]);
					TRACE("delete index -> " + (checkPlayList[i]-1));
				}
			}										
		} else { // 선택 항목만 지우기
			if ( itemList.length && itemList[lastContentsIndex-1] ) {
				TRACE("lastContentsIndex :::: "+ lastContentsIndex);
				itemList[0].parentNode.removeChild(itemList[lastContentsIndex-1]);
				TRACE("delete index -> " + (lastContentsIndex-1));
			}
		}
	}

	response = doc.documentElement;
	if ( !response ) {
		stopLoadingonList();
		curPopup = POPUP_NOTICE;			
		openPopupWithTimer (SID_ERRMSG_XML, popupCallback, 5);
		return;
	}		
	itemList = response.getElementsByTagName("item");
	TRACE("itemList = " + itemList.length);
	
	historyXML = "<?xml version='1.0' encoding='utf-8'?>";
	makeHistoryXMLText(response);
	if (bMaple)
		writeHistoryFile();
	reloadCategorylist();	
	initCheckList();
}
/**
 * @brief			방문기록 모두 삭제
 * @remarks		방문기록 모두 삭제
 * @param		void
 * @return	 	void
*/
function deleteAllHistory() {
	TRACE("deleteAllHistory");
	resetHistoryFile();
	initCheckList();
	reloadCategorylist();	
}

/**
 * @brief			방문기록 삭제 팝업 후 yes, no 버튼에 따른 동작
 * @remarks		yes 를 누르면,  방문기록 삭제, no를 누르면, 마지막 선택항목으로 포커스 이동
 * @param		void
 * @return	 	void
*/
function historyPopupCallback(button) {

	if (button == 0) {	// if YES
		deleteHistory();
	} else {				// if No
		TRACE("lastFocusID = " + lastFocusID);	
		TRACE("Focus to lastContentsID = " + lastContentsID);
		document.getElementById(lastContentsID).focus();
	}
}

/**
 * @brief			방문기록 삭제 팝업 엔터키 동작 정의
 * @remarks		방문기록 삭제 팝업 엔터키 동작 정의
 * @param		EKC		Key Event
 * @param		obj		Key 입력을 받는 html object
 * @return	 	void
*/
function delHistory_inputKey(EKC, obj) {
	var Idx = obj.name; 
	var tmpLastContentsID = lastContentsID;
	TRACE(" lastContentsID :: "+lastContentsID);
	CommonLib.keyHandler(EKC,popupCallback);	
	switch (EKC) {
//        case (13) : 						//Enter
        case (tvKey.KEY_ENTER) : 	//Enter       
        case (tvKey.KEY_PANEL_ENTER) : 		// 패널 키 Enter
        case (tvKey.KEY_PANEL_SOURCE) : 	// 패널 키 Source
			TRACE("checkListCnt ::" + checkListCnt);
			if(checkListCnt == 0){
				if ( Idx == 1 ) { // 하나만 지우기
				bDeleteAll = false;
				TRACE("bDeleteAll = " + bDeleteAll);
				sendMsg = SID_BOOKMARK_DEL_CONFIRM; //"선택된 항목을 삭제하시겠습니까?";
				} else if( Idx == 2) {	// 모두 지우기 
					selectAllCheckList(lastContentsIndex);			
				} 
				else {
					deleteAllCheckList(lastContentsIndex);	
				}	
			}else{
				if ( Idx == 1 ) { // 하나만 지우기
					var tmpMsg = "";
					bDeleteAll = false;
					TRACE("bDeleteAll = " + bDeleteAll);
					sendMsg = SID_BOOKMAKR_CHECK_DEL_STATE1;
					sendMsg = sendMsg.replace("[xxxxx]", checkListCnt);				
				} else if( Idx == 2){	// 전체선택
					selectAllCheckList(lastContentsIndex);
				} else {	//전체선택해제
					deleteAllCheckList(lastContentsIndex);	
				}	
			}
			
			hideOptionPopup();
			lastFocusID = tmpLastContentsID;
			if( Idx == 1) 	{
				curPopup = POPUP_DELBOOK;
				openPopupFocusWithTimer(sendMsg, historyPopupCallback, SID_YES,SID_NO, 30);
			}				
			else 
				document.getElementById(lastFocusID).focus();
        	break;
		default  : 
			
        	return false;
        	break;
	}
}

// ===================================================
// 연관 동영상
// ===================================================
/**
 * @brief			XML http request ready state 값 검사
 * @remarks		XHR에서 status가 바뀔때 마다 호출이 되며, state가 done(4)이 되면 true를 리턴한다.
* @param		obj			XHR Object
* @return       boolean	true 성공, false  실패
*/
function checkReadyStateRelated(obj, type) {
	if ( obj == null ) {
		TRACE("no obj to cheeck in checkReadyState :: " + type + " ::" + obj);
		return fasle;
	}
	TRACE(type + ":::::" + obj.readyState);
	if(obj.readyState == 3) {
        // Watch Dog 실행을 중지시킨다.
        offWatchDog();
	} else 	if(obj.readyState == 4) {
        // Watch Dog을 실행시킨다.
        onWatchDog();

	    if(obj.status == 200 || obj.status == 201) {
			return true;
	    } else if(obj.status == 403) {
			TRACE("Authentication ERROR", TRACE_LEVEL.ERROR);
			return false;
		} else {
			TRACE( " obj.status = " + obj.status);
			return false;
    	}
	}
}

/**
 * @brief			연관검색 xhr 객체 abort
 * @remarks		연관검색 xhr 객체 abort
* @param		void
* @return		void
*/
function abortRelatedXHR() {
	if ( xmlHttpRelated != null && xmlHttpRelated.readyState<4 )  {
		xmlHttpRelated.abort();
		TRACE("xmlHttpRelated abort!!");
	}
}
/**
 * @brief			연관검색 feed 요청
 * @remarks		연관검색 feed 요청
* @param		url		연관검색 url
* @return		void
*/
function loadRelatedVideoXML(url) {
	var tempHeader;
	var strParam;
	TRACE("loadRelatedVideoXML");
	abortRelatedXHR();
	
    if (window.XMLHttpRequest) 	{
        // code for Mozilla, etc.
        if(xmlHttpRelated==null) {
            xmlHttpRelated=new XMLHttpRequest();
        }else{
			xmlHttpRelated.destroy();
			xmlHttpRelated=new XMLHttpRequest();
		}
    } else if (window.ActiveXObject) {
        // code for IE
		if(xmlHttpRelated==null)
        	xmlHttpRelated = new ActiveXObject("Microsoft.XMLHTTP")
    }
	
    if (xmlHttpRelated!=null) {
		// Url Signing
		var bSign = requestSigning(url);
		if ( !bSign || digestSign64.length <= 0 ) {
			TRACE("requestSigning FAILED!");
			TRACE("lastFocusID = " + lastFocusID);
			return ;
		}
//		TRACE("deviceID = " + deviceID);
//		TRACE("digestSign64 = " + digestSign64);
		tempHeader = "device-id=" + deviceID + ", data=" + digestSign64 ;
		strParam = getParam(url);		
		// 로딩중 이미지 뿌리기
//		startLoadingonList();
        xmlHttpRelated.onreadystatechange=onLoadRelatedVideo;
		xmlHttpRelated.open("GET",url,true);
		xmlHttpRelated.setRequestHeader('X-GData-Device', tempHeader);
		xmlHttpRelated.send(strParam);
    }
    else 	{
        TRACE("Your browser does not support XMLHTTP.", TRACE_LEVEL.INFO);
    }	
}

/**
 * @brief			연관검색 xml feed 처리
 * @remarks		연관검색 xml feed 처리
* @param		void
* @return		void
*/
function onLoadRelatedVideo() {
	var strXHRObject = "xmlHttpRelated";
	if(checkReadyState(xmlHttpRelated, strXHRObject)) {
		if ( !bMaple ) {
			var xmlText = xmlHttpRelated.responseText;
			// code for IE
			if (window.ActiveXObject){
			 	var doc=new ActiveXObject("Microsoft.XMLDOM");
			  	doc.async="false";
			  	doc.loadXML(xmlText);
			}
			// code for Mozilla, Firefox, Opera, etc.
			else {
			  	var parser=new DOMParser();
			  	var doc=parser.parseFromString(xmlText,"text/xml");
			  }		
		} else { // Maple
			var doc = null;
			doc = xmlHttpRelated.responseXML;
			

		}
		var response = doc.documentElement;
		TRACE("response = " + response);
		if ( !response ) {
//			stopLoadingonList();
			TRACE("XML Error");
			return;
		}
		var tmpList = response.getElementsByTagName("item");

        relContentsList = new Array();
        relContentsImg = new Array();
        relDetailInfoListXmlURL = new Array();
		relContentsTime 	= new Array();		//오른쪽메뉴 리스트의 날짜, 시간정보 for 영문버전
		relContentsTimeUpdate 	= new Array();		//오른쪽메뉴 리스트의 날짜, 시간정보 for 한글버전
		relVideoGuid 		= new Array();		//Video ID
		relPlayURL 			= new Array();		//동영상 URL
		relPlayURL264 		= new Array();		//동영상 URL		
		relPlayerType 		= new Array();
		relDescription 		= new Array();		// 동영상 정보 내용
		relDuration 			= new Array();
		relViewcount 		= new Array();
		relAverage 			= new Array();
		relKeyWords 		= new Array();
		var i;
		for(i = 0 ; i < tmpList.length ; i++) {
			// 이미지영역
			var tmpImg = tmpList[i].getElementsByTagName("media:thumbnail");
			if (tmpImg && tmpImg.length) {
				relContentsImg[i] = tmpImg[0].getAttribute('url');
			} else {
				relContentsImg[i] = "";
			}
			// Video ID
            var tmpGuid =  tmpList[i].getElementsByTagName("guid");
            if (tmpGuid && tmpGuid.length) {
				var tmpNode = tmpGuid[0].firstChild;
				if (tmpNode) {
                	relVideoGuid[i] = tmpNode.data;
				}
				else {
					relVideoGuid[i] = "";
					TRACE("index " + i + " has no relVideoGuid");
				}
            } else {
				relVideoGuid[i] = "";
			}
			// 날짜 for 영문버전 
            var tmpDate =  tmpList[i].getElementsByTagName("pubDate");
            if (tmpDate && tmpDate.length) {
				var tmpNode = tmpDate[0].firstChild;
				if (tmpNode)
                	relContentsTime[i] = tmpNode.data;
				else {
					relContentsTime[i] = "";
					TRACE("index " + i + " has no relContentsTime");
				}
            } else {
				relContentsTime[i] = "";
			}
			// Update 날짜 for 한글버전 
            var tmpDateUpdate =  tmpList[i].getElementsByTagName("atom:updated");
            if (tmpDateUpdate && tmpDateUpdate.length) {
				var tmpNode = tmpDateUpdate[0].firstChild;
				if (tmpNode)
                	relContentsTimeUpdate[i] = tmpNode.data;
				else {
					relContentsTimeUpdate[i] = "";
					TRACE("index " + i + " has no relContentsTimeUpdate");
				}
            } else {
				relContentsTimeUpdate[i] = "";
			}
			// 제목
			var tmpName = tmpList[i].getElementsByTagName("title");
            if (tmpName && tmpName.length) {
				var tmpNode = tmpName[0].firstChild;
				if ( tmpNode )
        			relContentsList[i] = tmpNode.data;
				else {
					relContentsList[i] = "";
					TRACE("index " + i + "has no relContentsList");
				}
            } else {
				relContentsList[i] = "";
			}
			// 동영상 URL
			var tmpPlayUrl = tmpList[i].getElementsByTagName("media:player");
            if (tmpPlayUrl && tmpPlayUrl.length) {
        		relPlayURL[i] = tmpPlayUrl[0].getAttribute('url');
            } else {
				relPlayURL[i] = "";
			}
			// 동영상 264 URL
			var videoType;
			var videoDuration;
			var tmpPlayUrl264 = tmpList[i].getElementsByTagName("media:content");
			relPlayURL264[i] = "";
			for ( var j=0; j<tmpPlayUrl264.length; j++) {
				videoType = tmpPlayUrl264[j].getAttribute('type');
				videoDuration = tmpPlayUrl264[j].getAttribute('duration');
				if ( videoType.indexOf("mp4") > -1 ) {
	        		relPlayURL264[i] = tmpPlayUrl264[j].getAttribute('url');
					relPlayerType[i] = videoType;
					relDuration[i] = videoDuration;
				}
			}
			// 상세정보
			var tmpDesc = tmpList[i].getElementsByTagName("description");
            if ( tmpDesc && tmpDesc.length) {
				var tmpNode = tmpDesc[0].firstChild;
				if ( tmpNode )
        			relDescription[i] =  tmpNode.data;
				else {
					relDescription[i] = "";
					TRACE("index " + i + " has no relDescription");
				}
            } else {
				relDescription[i] = "";
			}
			// 조회수
            var tmpCount =  tmpList[i].getElementsByTagName("yt:statistics");
            if (tmpCount && tmpCount.length) {
				relViewcount[i] = tmpCount[0].getAttribute('viewCount');
            } else {
				relViewcount[i] = 0;
			}
			// 점수
            var tmpRating =  tmpList[i].getElementsByTagName("gd:rating");
            if (tmpRating && tmpRating.length) {
				relAverage[i] = tmpRating[0].getAttribute('average');
            } else {
				relAverage[i] = 0;
			}
			// 키워드
            var tmpKeywords =  tmpList[i].getElementsByTagName("media:keywords");
            if (tmpKeywords && tmpKeywords.length) {
				var tmpNode = tmpKeywords[0].firstChild;
				if ( tmpNode )
					relKeyWords[i] = tmpNode.data;
				else {
					relKeyWords[i] = "";
					TRACE("index " + i + " has no relKeyWords");
				}
            } else {
				relKeyWords[i] = "";
			}
		}
		
        gRelContentsListNum = tmpList.length;
		TRACE("gRelContentsListNum = " + gRelContentsListNum);

	}	
}

/**
 * @brief			연관검색 url 생성
 * @remarks		video guid 를 넘기면 연관검색 url 생성하여 리턴한다.
* @param		strURL		video Guid
* @return		strReturn	연관검색 url
*/
function getRelatedUrl(strURL) {
	var strReturn = "";
	var strParam = "/related?alt=rss&format=3&client=ytapi-samsung-tv";
	strReturn = strURL + strParam;
//	TRACE("Related URL = " + strReturn);
	return strReturn;
}

/**
 * @brief			파일에 text를 쓴다.
 * @remarks		파일에 text를 쓴다.
* @param		strFile		파일명
* @param		strText		저장할 Text
* @return		void
*/
function writeFile( strFile, strText ) {
	var fs = new FileSystem();

//	offWatchDog();
    if (fs.isValidCommonPath(favoriteDir) == 0) {
        TRACE("Common Directory is not Found!!!", ERROR)
        fs.createCommonDir(favoriteDir);
    }
	
	var fp = fs.openCommonFile(favoriteDir+"/"+strFile, "w");
	
	if(fp) {		// returns true-false
    	var strReturn = fp.writeAll(strText);
		TRACE(strReturn);
		fs.closeFile(fp);					// closes file
		TRACE("File Write Success!!!");
	} else {
		TRACE("File Write Fail!!!", TRACE_LEVEL.ERROR);
    }	
//	onWatchDog();	
}

/**
 * @brief			연관 비디오 화면 HTML 생성 
 * @remarks		Title과 description을 뿌리고 나서 플러그인에 동영상 Play 명령을 준다.
* @param		nIndex		상세정보 index, 0 base
* @return		void
*/
function createRelatedHTML(nIndex) {
	TRACE("createRelatedHTML nIndex = " + nIndex);
	if ( nIndex < 0 || nIndex >= gRelContentsListNum ) {
		TRACE("nIndex val is out of bound!");
		nIndex = 0;
	}
	bRelated = true;		
	var tmpViewCnt = "";
	var tmpPupdate = "";
	var tmpKeywords = "";
	var keyWordsTxt = "";
	var strViewCount = "0";
//	detailIndex = nIndex;
	changeButton();

	var tmpStrPupdate = relContentsTime[nIndex];
	tmpPupdate = transferPupdateExpression(tmpStrPupdate);

	strViewCount = getCommaNum(relViewcount[nIndex]);
	tmpViewCnt = SID_VIEWS + " : " + strViewCount + "&nbsp;&nbsp;&nbsp;" + SID_RATEAVG_ABBR_10 + " : " + "<img src=" + getStarImg(relAverage[nIndex]) + ">";
	keyWordsTxt = strlength_cut(70, relKeyWords[nIndex]);
	tmpKeywords = SID_KEYWORD_ABBR_10 + " : " + keyWordsTxt;

	//document.getElementById('uccTitle').innerHTML = "<a id='controlButton' href=javascript: onfocus=onFocusControl(this); ><table border=0 style='table-layout:fixed;vertical-align:top;'><tr><td height='45px' valign='middle' style='overflow:hidden;'>"  + strlength_cut(64, relContentsList[nIndex]) + "</td></tr></table></a>";	
	document.getElementById('uccTitleText').innerHTML = relContentsList[nIndex]+"<a id='controlButton' href=javascript: onfocus=onFocusControl(this); >&nbsp;</a>";
	document.getElementById('helpTitle').innerHTML = relContentsList[nIndex]; //full 화면에서 보여주기 위해 타이틀 저장.
	document.getElementById('uccDescription').innerHTML = relDescription[nIndex];
    document.getElementById('uccDescription').innerHTML += "<a id='detailDesc' href=javascript: onfocus=onFocusControl(this); >&nbsp;</a>";
	document.getElementById('uccCount').innerHTML = tmpViewCnt;
    document.getElementById('uccDate').innerHTML = tmpPupdate;
    document.getElementById('uccKeywords').innerHTML = tmpKeywords;	
    document.getElementById('uccCopyright').innerHTML = SID_COPYRIGHT_ABBR_10;	
	document.getElementById('uccCopyrightAddr').innerHTML = SID_COPYRIGHT_ADDRESS;	
	
	hideDetailscroll();
    hideScrollBar();
	hideVerticalBar();	
	showDetail();
	initPlayTime();
//	var uccURL;
	if ( bH264 && relPlayURL264[nIndex].length ) {
		g_uccURL = mp4Pre + relPlayURL264[nIndex] + mp4Post;
	} else {
		g_uccURL = relPlayURL[nIndex];
	}
	contentsObj = new contentsListObj(relContentsList[nIndex], 
								  relContentsImg[nIndex],
								  relDetailInfoListXmlURL[nIndex],
								  relContentsTime[nIndex],
								  relContentsTimeUpdate[nIndex],								  
								  relVideoGuid[nIndex],
								  relPlayURL[nIndex],
								  relPlayURL264[nIndex],
								  relPlayerType[nIndex],
								  relDescription[nIndex],
								  relDuration[nIndex],
								  relViewcount[nIndex],
								  relAverage[nIndex],
								  relKeyWords[nIndex]
								  );
	setTimeout("showDetailscroll()", 100); 

	TRACE("#########################################################" );
	TRACE("################## player PLAY call! ####################" );
	TRACE("#########################################################" );	

	currentStatus = UCC_PLAY;
	document.getElementById(focusItem1X).focus();
	bReturnLock = true;
	setDetailinputKeyTimer();				// 상세화면에서 2초동안은 복귀, 이전/다음 키 먹지 않도록 수정함.
	setTimeout("playerPlay()", 500); // 브라우저 타이밍 문제로 잠시 후 Play 호출, 그렇지 않으면 실행 시점이 오락가락함...
	
	if ( getMute() == 1 ) {
		showVolume();
	}

	if ( currentMode == UCC_MODE_1X )
		lastFocusID = focusItem1X; //"controlButton";				
	else
		lastFocusID = focusItemFull; //"fullMovieFocusItem";
		
	if ( bMaple) {
//		addHistory(); // 방문기록 추가 
		RelatedAddHistory(nIndex);	
	}	
}

